<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 5.0.0
	 */

	/**
	 *	eBag language loader
	 *	Load once into mem to all users
	 */

	/**
	 *	Usage:	$lang=new Lang($file, $apc, $reload);
	 *		echo $lang->get('key', 'insert');
	 *	Lang file syntax:  key=val\n
	 */

	class Lang	{
	
		var $LANG = array();

		/**
		 * Reads language file into array & store 
		 */

		function __construct($file=FALSE, $apc=FALSE, $reload=FALSE)	{

			if (! function_exists('apc_fetch')) $apc = FALSE;
		
			if ($apc)	{
			
				if ((! $reload) && apc_exists('eBagLang'))	{
			
					$this->LANG = apc_fetch('eBagLang');
					
					return;
				}
			}
			
			$lang	=	@file($file);

			if ($lang===FALSE) exit("Fatal error: language file $file not found ! Please contact your system administrator !");

			foreach ($lang as $line) $this->store($line);

			if ($apc) apc_store('eBagLang', (array)$this->LANG, 0);
		}

		/**
		 * Returns text by key
		 */

		public function get($key, $s=FALSE)	{
		
			$val = FALSE;
			
			if (isset($this->LANG[$key]))	{
			
				$val = $this->LANG[$key];
				
				# sprintf
				
				if ((is_numeric($s) or $s) && ($r = @implode($s, @mb_split('%s', $val)))) $val=$r;
			}

			return $val;
		}

		/**
		 * Store one line of text into memory
		 */

		private function store($line)	{

			if (! strlen(mb_eregi_replace('\s', '', $line))) return;
 
			list($key, $val) = mb_split('=>', $line);
			
			$this->LANG[mb_eregi_replace('\s', '', $key)] = mb_eregi_replace('^\s*|\s*$', '', $val);
		}
	}

?>
