<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 *	eBag navigation language loader
	 */

	/**
	 *	Usage:	$lang=new Lang('eng');
	 *	Lang file syntax: [section]
	 *			  key=>val\n
	 */

	require(BASEDIR.'/functions/mb_ereg_match_str.php');

	class LangNav	{

		var $LANG	=	array();
		var $SECT	=	array();


		/**
		 * Reads language file into array & store 
		 */

		function __construct($file)	{

			$lang	=	@file($file);

			if ($lang===FALSE) trigger_error("Language file $file not found.", E_USER_ERROR);

			foreach ($lang as $line) $this->store($line);
		}

		/**
		 * Returns LANGUAGE (sections=>categories)
		 */

		public function getLANG()	{

			return $this->LANG;
		}

		/**
		 * Returns SECTIONS (sections=>section names)
		 */

		public function getSECT()	{

			return $this->SECT;
		}

		/**
		 * Analize & store data
		 */

		private function store($line)	{

			static $section='';

			if (! strlen(mb_eregi_replace('\s', '', $line))) return;

			// read sections
			
			if (mb_ereg_match_str('\[(.*?)\]', $line, $sect, 'i'))	{

				list($key, $val)	=	mb_split('=>', mb_eregi_replace('^\[|\]$', '', $sect));
				$section		=	mb_eregi_replace('\s', '', $key);
				$this->LANG[$section]	=	array();
				$this->SECT[$section]	=	mb_eregi_replace('^\s*|\s*$', '', $val);
				return;
			}
		
			// read variable into sections
			list($key, $val) = mb_split('=>', $line);

			$this->LANG[$section][mb_eregi_replace('\s', '', $key)] = mb_eregi_replace('^\s*|\s*$', '', $val);
		}
	}
?>
