<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag language depend payments loader to write into base at install
	 */

	class PAYMENTSINSTALLER	{

		var $PAYMENTS		=	array();
		var $PAYMENTSVALUES	=	array();
		var $DEFAULTPAYMENT	=	FALSE;

		function __construct($file)	{
		
			global $new;
			
			$this->SQL = &$new;

			$lines	=	@file($file);

			if ($lines===FALSE) trigger_error("language file $file not found", E_USER_ERROR);

			$this->store($lines);
		}

		# store payments into memory

		private function store($lines)	{

			$PAYMENTS	=	array();

			foreach ($lines as $line)	{

				if (! strlen(mb_eregi_replace('\s', '', $line))) continue;

				list($key, $val) = mb_split('=>', $line);

				$key = mb_eregi_replace('^\s*|\s*$', '', $key);

				# store default

				if ($key == 'default')	{

					$this->DEFAULTPAYMENT	= 	$this->SQL->escape(mb_eregi_replace('^\s*|\s*$', '', $val));

					continue;
				}

				# store it for write to mysql

				$this->PAYMENTS[]		=	$this->SQL->escape($key);

				$this->PAYMENTSVALUES[]		=	$this->SQL->escape(mb_eregi_replace('^\s*|\s*$', '', $val));
			}
		}

		# returns payment names as associative array

		public function getnames()	{

			return $this->PAYMENTS;
		}

		# returns payment values as associative array

		public function getvalues()	{

			return $this->PAYMENTSVALUES;
		}

		# returns default payment 

		public function getdefault()	{

			return $this->DEFAULTPAYMENT;
		}
	}


?>
