<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag stocks (services, stock, feedstock, operating suplies and unions) quicksearch
	 */

	class STOCKQUICKSEARCH	{

		var $TABLE	=	'';
		var $PAGINATION	=	'';
		var $COMMAND	=	'';
		var $WHOLE	=	FALSE;
		var $PAGE	=	0;
		var $NEWSEARCH	=	FALSE;
		var $INC	=	12;

		function __construct($STOCKTABLE)	{

			global $__SQL, $__LANG;

			$NAMES	=	array(	'services'		=>	'servicename',
						'feedstock'		=>	'feedstockname',
						'finished_goods_stock'	=>	'articalname',
						'operating_suplies'	=>	'supliename',
						'services_stock'	=>	'service_artical_name', 
						'feedstock_stock'	=>	'feedstock_artical_name' );

			$this->NAME		=	$NAMES[$STOCKTABLE];
			$this->STOCKTABLE	=	$STOCKTABLE;

			$this->SQL		=	&$__SQL;
			$this->LANG		=	&$__LANG;

			if (isset($_SESSION['year_is_closed']))	{

				$this->STOCKBASE = $_SESSION['BASE'];

			}	else	  {

				$this->STOCKBASE = 'ebagstock';
			}

			if (isset($_GET['page'])) 	{

				$this->PAGE	= (integer)$_GET['page'];
				$this->COMMAND	= $_SESSION['QUICKSEARCH'];
			}

			if ((isset($_POST['submit_search'])) or (isset($_POST['submit_all'])))	$this->COMMAND	= '';

			$this->FORMCOMMAND();

			$this->DRAWTABLE();

			if (isset($this->PAGENUM)) $this->PAGINATE();
		}
		

		/**
		 * Form the query
		 */

		private function FORMCOMMAND()	{

			$SEARCH	= $SEARCH1 = $SEARCH2 =	$PRICE_SQL = '';

			# note: PRICE must to be defined here

			if (($this->NAME != 'feedstockname') &&
			    ($this->NAME != 'feedstock_artical_name') && 
			    ($this->NAME != 'supliename')) $PRICE_SQL = ', `price`, `tax`';

			if (! $this->COMMAND)	{

				if ((isset($_POST['searchname'])) && (! is_empty($_POST['searchname'])))	{
				
					$searchname = $this->SQL->s_escape($_POST['searchname'], 'REGEXP');
				
					if ($this->NAME == 'service_artical_name')	{
					
					      $SEARCH1 .= "AND `articalname` REGEXP '$searchname'";
					      $SEARCH2 .= "AND `servicename` REGEXP '$searchname'";

					} elseif ($this->NAME == 'feedstock_artical_name') {
					
					      $SEARCH1 .= "AND `articalname` REGEXP '$searchname'";
					      $SEARCH2 .= "AND `feedstockname` REGEXP '$searchname'";
					
					} else	{
					
					      $SEARCH .= "AND `$this->NAME` REGEXP '$searchname'";
					}
				}

				if ((isset($_POST['code'])) &&  (! is_empty($_POST['code'])))	{
				
					$searchcode = $this->SQL->s_escape($_POST['code'], 'REGEXP');
					
					if (($this->NAME != 'service_artical_name') && ($this->NAME != 'feedstock_artical_name')) {
					
					      $SEARCH .= "AND `code` REGEXP '$searchcode'";
					      
					}	else	  {
					
					      $SEARCH1 .= "AND `code` REGEXP '$searchcode'";
					      $SEARCH2 .= "AND `code` REGEXP '$searchcode'";
					}
				}
				
				if ($this->NAME == 'service_artical_name')	{
				
					$this->COMMAND = "(	SELECT SQL_CALC_FOUND_ROWS `personID`, `articalname` as `name`, `code`, `unit` , `price`, `tax`, 'a' AS `type` 
								FROM $this->STOCKBASE.finished_goods_stock 
								WHERE `deleted` IS NOT NULL ".$SEARCH1." 
								ORDER BY `personID` 
							  ) 
							  UNION ALL 
							  (
								SELECT `personID`, `servicename` as `name`, `code`, `unit` , `price`, `tax`, 's' AS `type` 
								FROM $this->STOCKBASE.services 
								WHERE `deleted` IS NOT NULL ".$SEARCH2." 
								ORDER BY `personID` 
							  )";
				
				} elseif ($this->NAME == 'feedstock_artical_name')	{
				
					$this->COMMAND = "(	SELECT SQL_CALC_FOUND_ROWS `personID`, `articalname` as `name`, `code`, `unit` , 'a' AS `type` 
								FROM $this->STOCKBASE.finished_goods_stock 
								WHERE `deleted` IS NOT NULL ".$SEARCH1." 
								ORDER BY `personID` 
							  ) 
							  UNION ALL 
							  (
								SELECT `personID`, `feedstockname` as `name`, `code`, `unit` , 'f' AS `type`
								FROM $this->STOCKBASE.feedstock 
								WHERE `deleted` IS NOT NULL ".$SEARCH2." 
								ORDER BY `personID` 
							  )";
				
				} else {
				
					$this->COMMAND = "SELECT SQL_CALC_FOUND_ROWS `personID`, `$this->NAME` as `name`, `code`, `unit` $PRICE_SQL
							  FROM $this->STOCKBASE.$this->STOCKTABLE 
							  WHERE `deleted` IS NOT NULL ".$SEARCH.' 
							  ORDER BY `personID` ';
				}
				
				$_SESSION['QUICKSEARCH'] = $this->COMMAND;
			}

			$this->COMMAND .= ' LIMIT '.($this->PAGE * $this->INC).', '.$this->INC;
		}

		/**
		 * Count the pages
		 */

		private function PAGECOUNT()	{

			if (! $this->WHOLE) return;

			if ($this->WHOLE < $this->INC)	{

				$this->PAGENUM	=	0;

			}	else 	{ 

				if ($this->WHOLE % $this->INC==0) {$correct=1;} else {$correct=0;}

				$this->PAGENUM = floor($this->WHOLE / $this->INC)-$correct;
			}
			
			unset($this->WHOLE);

			$this->NUMROWS = $this->SQL->RESULT->num_rows;
		}

		/**
		 * Execute query
		 */

		private function DRAWTABLE()	{

				$this->SQL->query($this->COMMAND);

				$this->WHOLE = $this->SQL->calc_rows();

				if (! $this->WHOLE)	{

					$ERRTXT	=	$this->LANG->get('noresult');	

					$this->TABLE .= "<table>\n<tr><td class=\"link\" colspan=\"2\">$ERRTXT</td></tr>\n</table>";

					return;
				}
	
				$this->PAGECOUNT();

				$INC = 0;
				$this->TAB = 5;

				while ($RESULT = $this->SQL->RESULT->fetch_assoc())	{

					$personID	=	$RESULT['personID'];
					$code		=	$RESULT['code'];
					$name		=	$RESULT['name'];
					$unit		=	$RESULT['unit'];
					
					if (isset($RESULT['type'])) $type = $RESULT['type'];
					
					if (isset($RESULT['price']))	{
					
						$price	=  	$RESULT['price'];
						$tax	=	$RESULT['tax'];
					}
					
					if ($this->NUMROWS == ($INC + 1))	{

						$NEXTFIELD = 'onkeypress="return nextfield(this, event, \'check_0\')"';

					}	else	{

						$next = $INC+1;

						$NEXTFIELD = "onkeypress=\"return nextfield(this, event, 'check_$next')\"";
					}

					$this->TABLE	.=	<<<"EOT"
								<tr>
									<td><input type="checkbox" name="check_$INC" value="$personID" tabindex=$this->TAB onfocus="code2form(this, $INC)" onclick="code2form(this, $INC)" $NEXTFIELD></td>
									<td><input readonly style="width: 110px" name="code_$INC" value="$code"></td>
									<td><input readonly style="width: 140px" name="name_$INC" value="$name">
									<input class="textbox" type="hidden" name="unit_$INC" value="$unit">
EOT;
					if (isset($price)) $this->TABLE .= "<input class=\"textbox\" type=\"hidden\" name=\"price_$INC\" value=\"$price\">"
									 ."<input class=\"textbox\" type=\"hidden\" name=\"tax_$INC\" value=\"$tax\">";
									 
					if (isset($type)) $this->TABLE .= "<input class=\"textbox\" type=\"hidden\" name=\"type_$INC\" value=\"$type\">";

					$this->TABLE	.=	'</td></tr>';

					$INC++;
					
					$this->TAB++;
				}
				
				$this->TABLE	=	"<table class=\"searchresult\">\n"
							.'<tr><td></td><td class="label">'.$this->LANG->get('code').'</td><td class="label">'.$this->LANG->get('quickname')."</td></tr>\n"
							.$this->TABLE
							.'</table>';

				$this->SQL->free();
		}

		private function PAGINATE()	{

			$SELF	= backward();

			$BACKWARD = $FORWARD = 0;

			if ((! $this->PAGE) && ($this->PAGENUM))	{

				$FORWARD	=	$this->PAGE+1;
			}

			if (($this->PAGE==$this->PAGENUM) && ($this->PAGE))	{

				$BACKWARD 	=	$this->PAGE-1; 
				$FORWARD	=	$this->PAGE;
			}

			if (($this->PAGE) && ($this->PAGE!=$this->PAGENUM))	{

				$BACKWARD	=	$this->PAGE-1; 
				$FORWARD	=	$this->PAGE+1;
			}

			$tab1 = $this->TAB++;
			$tab2 = $this->TAB++;
			$tab3 = $this->TAB++;
			$tab4 = $this->TAB++;

			$this->PAGINATION	=	<<<"EOT"
					<table class="pagination">
						<tr>
							<td><a href="$SELF&amp;page=0" tabindex=$tab1><img src="../images/tstart.png" width="9" height="9" border="0" alt="start"></a></td>
							<td><a href="$SELF&amp;page=$BACKWARD" tabindex=$tab2><img src="../images/tbackward.png" width="9" height="9" border="0" alt="backward"></a></td>
							<td><a href="$SELF&amp;page=$FORWARD" tabindex=$tab3><img src="../images/tforward.png" width="9" height="9" border="0" alt="forward"></a></td>
							<td><a href="$SELF&amp;page=$this->PAGENUM" tabindex=$tab4><img src="../images/tend.png" width="9" height="9" border="0" alt="end"></a></td>
						</tr>
					</table>
EOT;
		}
	}

?>
