<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag direct enter into stock
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	check_year_for_write('stock');

	pagepermission('stock', 'w');

	if (isset($_POST['submit']))	{

		unset($_POST['submit']);

		load_c('SQL');

		$__SQL	= new SQL();

		load_m('directstockenter');

		$__STOCK	=	new DIRECTSTOCKENTER('finished_goods_stock');

		$RESULT		=	$__STOCK -> enter($_POST);

		unset($__STOCK, $__SQL);

		if ($RESULT === TRUE)	{

			$view	=	new View('sucessbox');
			$view	->	assign('SELF', backward());
			$view	->	assign('MESSAGE', $__LANG->get('datawritten'));
			$view	->	assign('OK', $__LANG->get('ok'));
			$view	->	assign('BACKTO', backward());
			$view	->	display();
			exit;
		}

		$view	=	new View('errorbox');
		$view	->	assign('SELF', backward());
		$view	->	assign('ERROR', $__LANG->get('error'));
		$view	->	assign('ERRTXT', $__LANG->get($RESULT));
		$view	->	assign('BACK', $__LANG->get('back'));
		$view	->	display();
		exit;
	}

	if (isset($_POST['selected']))	{

		# go to second view for enter quantity

		load_c('SQL');

		$__SQL	=	new SQL();

		if ((! is_empty($_POST['code'])) && (is_empty($_POST['id'])))	{

			load_m('idsearch');

			$search	=	new IDSEARCH();

			$base	=	'ebagstock';

			$ID	=	$search	->	bycode($base.'.finished_goods_stock', $_POST['code']);

			unset($search);
			
		}

		if (! is_empty($_POST['id'])) $ID = $_POST['id'];

		if (isset($ID))	{

			load_m('articalread');

			$__STOCK	=	new ARTICALREAD();

			$ARTICALDATA	=	$__STOCK->read($ID);

			unset($__STOCK);
		}
		
		unset($__SQL);

		if ((! is_empty($_POST['code'])) && ($ARTICALDATA) && ($_POST['code'] != $ARTICALDATA['code'])) unset($ARTICALDATA);

		if ((! isset($ARTICALDATA)) or (! $ARTICALDATA))	{

			$view	=	new View('errorbox');
			$view	->	assign('SELF', backward());
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get('articalnotmatch'));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}

		$view	=	new View('enterquantity');
		
		$view	->	assign('ENTER_ORIGIN_AND_QUANTITY', $__LANG->get('enteroriginquantity'));
		$view	->	assign('PERSONID', $__LANG->get('personIDlong'));
		$view	->	assign('CODE', $__LANG->get('code'));
		$view	->	assign('NAME', $__LANG->get('articalname'));
		$view	->	assign('UNIT', $__LANG->get('unit'));
		$view	->	assign('BILL_NUMBER', $__LANG->get('bill_number'));
		$view	->	assign('DELIVERY_LIST_NUMBER', $__LANG->get('delivery_list_number'));
		$view	->	assign('QUANTITY', $__LANG->get('quantity'));
		$view	->	assign('STOCKITEMNAME', 'articalname');

		# form data

		$view	->	assign('ITEMID', $ID);
		$view	->	assign('ITEMCODE', $ARTICALDATA['code']);
		$view	->	assign('ITEMNAME', $ARTICALDATA['articalname']);
		$view	->	assign('ITEMUNIT', $ARTICALDATA['unit']);

		unset($ARTICALDATA);

		$view 	->	assign('WRITE', $__LANG->get('write'));
		$view 	->	assign('RESET', $__LANG->get('reset'));
		$view	->	assign('BACKTO', backward());
		$view 	->	assign('CANCEL', $__LANG->get('cancel'));	

		$view	->	display();
		exit;
	}

	# first view for select id & code

	$view	=	new View('idcodeenter');

	$view 	->	assign('ENTER_ID_OR_CODE', $__LANG->get('enterartical'));
	$view 	->	assign('PERSONID', $__LANG->get('articalbynumber'));
	$view 	->	assign('CODE', $__LANG->get('articalbycode'));
	$view 	->	assign('OK', $__LANG->get('ok'));
	$view 	->	assign('RESET', $__LANG->get('reset'));
	$view	->	assign('BACKTO', 'loader.php?cat=section&amp;id=stock');
	$view 	->	assign('CANCEL', $__LANG->get('cancel'));
	$view	->	display();
?>
