<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag contact change
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	check_year_for_write('addressbook');

	pagepermission('addressbook', 'w'); 

	if (isset($_GET['id']))		{

		$ID = $_SESSION['ID'] = $_GET['id'];
		
		unset($_SESSION['_POST_ERR']);

	}	else	  {

		$ID = $_SESSION['ID'];
	}

	load_c('SQL');

	$__SQL	= new SQL();

	load_m('contactread');

	if (isset($_POST['submit']))	{

		load_m('contactchange');

		$__CONTACT	=	new CONTACTCHANGE();

		$RESULT	=	$__CONTACT->change($ID, $_POST);
		
		unset($__CONTACT, $__SQL);

		if ($RESULT !==TRUE)	{
		
			$_POST['_err_address'] = backward();

			$_SESSION['_POST_ERR']	=  $_POST;

			$view	=	new View('errorbox');
			$view	->	assign('SELF', $_POST['_err_address']);
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get($RESULT));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}

		$view	=	new View('sucessbox');
		$view	->	assign('SELF', backward());
		$view	->	assign('MESSAGE', $__LANG->get('datawritten'));
		$view	->	assign('OK', $__LANG->get('ok'));
		$view	->	assign('BACKTO', $_SESSION['FROM']);
		$view	->	display();
		exit;
	}

	if (post_data_verified())	{

		$CONTACTDATA = enc_quotes($_SESSION['_POST_ERR']);
		
		unset($_SESSION['_POST_ERR']);

	}	else	 {

		if (! isset($__CONTACT)) $__CONTACT = new CONTACTREAD();

		$CONTACTDATA	=	$__CONTACT->read($ID);
	}

	unset($__SQL, $__CONTACT);

	if (! $CONTACTDATA)	{

		$view	=	new View('errorbox');
		$view	->	assign('SELF', $_SESSION['FROM']);
		$view	->	assign('ERROR', $__LANG->get('error'));
		$view	->	assign('ERRTXT', $__LANG->get('cannotread'));
		$view	->	assign('BACK', $__LANG->get('back'));
		$view	->	display();
		exit;
	}

	$_POST=$CONTACTDATA; unset($CONTACTDATA);

	$view	=	new View('contactchange');

	$view	->	assign('SELF', backward());
	$view	->	assign('CONTACTCHANGE', $__LANG->get('contactchange', $ID));
	$view	->	assign('NAME', $__LANG->get('contactname'));
	$view	->	assign('SECONDDELIVERY', $__LANG->get('seconddelivery'));
	$view	->	assign('CONTACTPERSON', $__LANG->get('contactperson'));
	$view	->	assign('DELIVERYCOUNTRY', $__LANG->get('deliverycountry'));
	$view	->	assign('COUNTRY', $__LANG->get('country'));
	$view	->	assign('DELIVERYCITY', $__LANG->get('deliverycity'));
	$view	->	assign('CITY', $__LANG->get('city'));
	$view	->	assign('DELIVERYZIP', $__LANG->get('deliveryzip'));
	$view	->	assign('ZIP', $__LANG->get('zip'));
	$view	->	assign('DELIVERYSTREET', $__LANG->get('deliverystreet'));
	$view	->	assign('STREET', $__LANG->get('street'));
	$view	->	assign('DELIVERYDAYOFWEEK', $__LANG->get('deliverydayofweek'));
	$view	->	assign('TELEPHONE1', $__LANG->get('telephone1'));
	$view	->	assign('TELEPHONE2', $__LANG->get('telephone2'));
	$view	->	assign('ACCOUNT1', $__LANG->get('account1'));
	$view	->	assign('ACCOUNT2', $__LANG->get('account2'));
	$view	->	assign('BANK1', $__LANG->get('bank1'));
	$view	->	assign('BANK2', $__LANG->get('bank2'));
	$view	->	assign('FAX', $__LANG->get('fax'));
	$view	->	assign('MOBILE', $__LANG->get('mobile'));
	$view	->	assign('MAIL', $__LANG->get('mail'));
	$view	->	assign('TAXIDNO', $__LANG->get('taxidno'));
	$view	->	assign('WEBSITE', $__LANG->get('website'));
	$view	->	assign('TYPE', $__LANG->get('contacttype'));
	$view	->	assign('CANCEL', $__LANG->get('cancel'));
	$view	->	assign('RESET', $__LANG->get('reset'));
	$view	->	assign('WRITE', $__LANG->get('write'));

	$DAYNAMES = 	array(1=>$__LANG->get('day1'), 2=>$__LANG->get('day2'), 3=>$__LANG->get('day3'), 4=>$__LANG->get('day4'), 5=>$__LANG->get('day5'), 6=>$__LANG->get('day6'), 0=>$__LANG->get('day0'));
	$view	->	assign('DAYNAMES', $DAYNAMES);	unset($DAYNAMES);

	$CONTACTTYPES	=	array();

	for ($i=0; $i<6; $i++) array_push($CONTACTTYPES, $__LANG->get("type$i"));

	$view	->	assign('CONTACTTYPES', $CONTACTTYPES); unset($CONTACTTYPES, $types);

	if (! isset($_POST['delivery']))	{

		$DISABLED	=	'disabled';
		$CHECKED	=	'';

	}	else	  {

		$DISABLED	=	'';
		$CHECKED	=	'checked';
	}

	if ((isset($_POST['delivery_country'])) or (isset($_POST['delivery_city'])) or
	    (isset($_POST['delivery_zip'])) or (isset($_POST['delivery_street'])))	$CHECKED='checked';

	$view	->	assign('DISABLED', $DISABLED);
	$view	->	assign('CHECKED', $CHECKED);
	$view	->	assign('BACKTO', $_SESSION['FROM']);

	$view	->	display();

?>
