<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag contact delete
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	check_year_for_write('addressbook');

	pagepermission('addressbook', 'w'); 

	load_c('SQL');

	$__SQL	= new SQL();

	# verifyed delete it

	if (isset($_POST['YES']))	{

		load_m('contactdelete');

		$__CONTACT = new CONTACTDELETE();

		$RESULT = $__CONTACT->delete($_POST['id']);

		unset($__CONTACT, $__SQL);

		if ($RESULT!==TRUE)	{

			$view	=	new View('errorbox');
			$view	->	assign('SELF', $_SESSION['FROM']);
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get($RESULT));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}

		$view	=	new View('sucessbox');
		$view	->	assign('SELF', backward());
		$view	->	assign('MESSAGE', $__LANG->get('contactdeleted', $_POST['id']));
		$view	->	assign('OK', $__LANG->get('ok'));
		$view	->	assign('BACKTO', $_SESSION['FROM']);
		$view	->	display();
		exit;
	}

	# input check

	$ID	= $_GET['id'];
	$TABLE	= $_SESSION['BASE'].'.addressbook';

	load_m('namesearch');

	$search= new NAMESEARCH();

	$NAME = $search->byID('contact', $TABLE, $ID);
	
	unset($search, $__SQL);

	if (! $NAME) 	{

		# record was deleted in meantime

		$view	=	new View('errorbox');
		$view	->	assign('SELF', backward());
		$view	->	assign('ERROR', $__LANG->get('error'));
		$view	->	assign('ERRTXT', $__LANG->get('alreadydeleted'));
		$view	->	assign('BACK', $__LANG->get('back'));
		$view	->	display();
		exit;
	}

	# verify

	$view	=	new View('verify');
	$view	->	assign('SELF', backward());
	$view	->	assign('QUESTION', $__LANG->get('suretodelcontact', $ID.' ('.$__LANG->get('contactname').': '.$NAME.')'));
	$view	->	assign('YES', $__LANG->get('yes'));
	$view	->	assign('NO', $__LANG->get('no'));
	$view	->	assign('ID', $ID);
	$view	->	assign('BACKTO', $_SESSION['FROM']);
	$view	->	display();

?>
