<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag file download
	 */ 

	# note: file download is not called via loader
	#	because of gzip compression

	define('BASEDIR', '../');

	# Load basic functions

	require_once(BASEDIR.'helpers/basichelpers.php');

	# Reads the configuration

	load_c('INIload');

	$__CONF	=	new INI_load(BASEDIR.'conf/eBag.ini');

	# Sets error handler	

	load_c('Errorhandler');

	$__HANDLER	=	new ERRHANDLER();
	$__HANDLER	->	start();

	# Sets session handler

	load_c('Sessionhandler');

	$__SESS	=	new MysqlSession();
	$__SESS	->	set_session_handler();
	
	register_shutdown_function('session_write_close');

	session_start();

	if ((! isset($_GET['file'])) or (! isset($_SESSION['uploaddir'])))	{

		exit('File not found.');
	}

	load_c('SQL');

	$__SQL	= new SQL();

	load_c('DOWNLOAD');

	new DOWNLOAD($_GET['file'], $__CONF->get('download', 'speed_kbs'));

?>
