<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag load backup
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	pagepermission('settings', 'w');
	
	check_for_backup_in_progress('settings');

	if ((isset($_POST['submit'])) && ($_POST['base']))	{

		load_c('SQLREAL');

		$__SQL	= new SQLREAL();

		load_c('RESTOREBACKUP');

		$__BACKUP	=	new RESTOREBACKUP();

		$__BACKUP	->	directory($__CONF->get('backup', 'directory'));

		if ((isset($_POST['restore_structure'])) && ($_POST['restore_structure'])) $__BACKUP->recreate_tables();

		$__BACKUP -> base($_POST['base']);

		$RESULT = $__BACKUP -> restore();
	
		$REPORT = $__BACKUP -> report();

		unset($__BACKUP, $__SQL);

		if ($RESULT !== TRUE)	{

			$view	=	new View('errorbox');
			$view	->	assign('SELF', backward());
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get($RESULT));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}

		$view	=	new View('restoredbackup');
		$view	->	assign('SELF', backward());
		$view	->	assign('LABEL', $__LANG->get('restoredbackup', $_POST['base']));
		$view	->	assign('REPORT', $__LANG->get('report'));
		$view	->	assign('REPORTSTRING', $REPORT);
		$view	->	assign('OK', $__LANG->get('ok'));

		$view	->	display();
		exit;
	}

	load_m('backuplist');

	$__BACKUP	=	new BACKUPLIST();

	$BASENAMES	=	$__BACKUP->getlist();

	unset($__BACKUP);

	if (! $BASENAMES)	{

		$view	=	new View('errorbox');
		$view	->	assign('SELF', 'loader.php?cat=section&amp;id=settings');
		$view	->	assign('ERROR', $__LANG->get('error'));
		$view	->	assign('ERRTXT', $__LANG->get('nobackupcopyfound'));
		$view	->	assign('BACK', $__LANG->get('back'));
		$view	->	display();
		exit;
	}

	load_f('mb_wrap');

	$view	=	new View('restorebackup');

	$view	->	assign('RESTORE_BACKUP', $__LANG->get('restore_backup'));
	$view	->	assign('RESTORE_BASE', $__LANG->get('restore_base'));
	$view	->	assign('RESTORE_TABLE_STRUCTURES', $__LANG->get('restore_structure'));
	$view	->	assign('RESTORE', $__LANG->get('restore'));
	$view	->	assign('WARNING', mb_wrap($__LANG->get('backupwarning'),50,'<br>'));
	$view	->	assign('CANCEL', $__LANG->get('cancel'));
	$view	->	assign('BACKTO', 'loader.php?cat=section&amp;id=settings');

	$view	->	assign('BASENAME', $BASENAMES); unset($BASENAMES);

	$view	->	display();


?>
