<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag new payment
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	check_year_for_write('payments');

	pagepermission('payments', 'w');

	load_c('SQL');

	$__SQL	= new SQL();

	if (isset($_POST['submit']))	{

		load_m('paymentswrite');

		$__PAYMENTS	=	new PAYMENTSWRITE();

		$RESULT		=	$__PAYMENTS->write($_POST);

		unset($__PAYMENTS, $__SQL);

		if ($RESULT !== TRUE)	{
		
			$_POST['_err_address'] = backward();

			$_SESSION['_POST_ERR']	=  	$_POST;

			$view	=	new View('errorbox');
			$view	->	assign('SELF', $_POST['_err_address'].'&amp;p_err=1');
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get($RESULT));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}

		$view	=	new View('sucessbox');
		$view	->	assign('SELF', backward());
		$view	->	assign('MESSAGE', $__LANG->get('datawritten'));
		$view	->	assign('OK', $__LANG->get('ok'));
		$view	->	assign('BACKTO', backward());
		$view	->	display();
		exit;
	}

	load_m('customers2payread');

	$__CUSTOMERS	=	new CUSTOMERSREAD();

	$CUSTOMERS	=	$__CUSTOMERS->read();

	unset($__CUSTOMERS);
	
	if (! $CUSTOMERS)	{

		$view	=	new View('errorbox');
		$view	->	assign('SELF', backward());
		$view	->	assign('ERROR', $__LANG->get('error'));
		$view	->	assign('ERRTXT', $__LANG->get('nocustomers2pay'));
		$view	->	assign('BACK', $__LANG->get('back'));
		$view	->	display();
		exit;
	}

	$view	=	new View('payment');

	$view	->	assign('SELF', backward());
	$view	->	assign('LABEL', $__LANG->get('newpayment'));
	$view	->	assign('CUSTOMER', $__LANG->get('customer'));
	$view	->	assign('PAYMENTID', $__LANG->get('paymentID'));
	$view	->	assign('DATE', $__LANG->get('date'));
	$view	->	assign('SUM', $__LANG->get('amount').' ('.$__CONF->get('payments', 'currency').') ');
	$view	->	assign('BANK', $__LANG->get('bank'));
	$view	->	assign('ACCOUNT', $__LANG->get('account'));
	$view	->	assign('COMMENT', $__LANG->get('comment'));
	$view	->	assign('WRITE', $__LANG->get('write'));
	$view	->	assign('RESET', $__LANG->get('reset'));
	$view	->	assign('CANCEL', $__LANG->get('cancel'));
	$view	->	assign('BACKTO', 'loader.php?cat=section&amp;id=payments');

	# form data

	$view	->	assign('CUSTOMERS', $CUSTOMERS);

	if (post_get_data_verified())	{

		$_POST = enc_quotes($_SESSION['_POST_ERR']);
		
		unset($_SESSION['_POST_ERR']);

	}	else	  {

		$_POST['date']	=	date($__CONF->get('date', 'dateformat'));
		
		load_m('bankread');
		
		$__BANK = new BANKREAD();
		
		list($_POST['bank'], $_POST['account']) = $__BANK->read();
		
		unset($__BANK);
	}
	
	unset($__SQL);

	$view	->	display();

?>
