<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag new production order to stock
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	check_year_for_write('production');

	pagepermission('production', 'w');
	
	if ((! isset($_GET['p_err'])) && isset($_SESSION['_POST_ERR'])) unset($_SESSION['_POST_ERR']);

	if (isset($_POST['submit']))	{
	
		unset($_POST['submit']);
		
		# store collected dat in session var & redirect to next page
	
		$_SESSION['NEW_PROD_ORDER_TO_STOCK_DATA'] = $_POST;

		# redirect to create new

		header("location: loader.php?cat=newproductionorder2stock&new=1");

		exit;
	}	
	
	if (post_data_verified())	{
	
		$_POST = enc_quotes($_SESSION['_POST_ERR']);
		
		unset($_SESSION['_POST_ERR']);
	
	}	else	  {
	
		$_POST['date_of_creation'] = date($__CONF->get('date', 'dateformat'));
		
		$_POST['date_of_deadline'] = date($__CONF->get('date', 'dateformat'), strtotime($__CONF->get('delivery', 'default_deadline_for_shipment').' days'));
	
	}
	
	unset($_SESSION['NEW_PROD_ORDER_TO_STOCK_DATA']);

	$view	=	new View('newproductionorder2stock');

	$view	->	assign('SELF', backward());
	$view	->	assign('NEW_PRODUCTION_ORDER_TO_STOCK', $__LANG->get('newproductionorder2stock'));
	$view	->	assign('CODE', $__LANG->get('code'));
	$view	->	assign('QUANTITY', $__LANG->get('quantity'));
	
	$view	->	assign('STOCK_TYPE', $__LANG->get('stockitemtype'));
	$view	->	assign('FINISHED_GOOD', $__LANG->get('finishedgood'));
	$view	->	assign('OPERATING_SUPLIE', $__LANG->get('operatingsuplie'));
	
	$view	->	assign('DATE_OF_CREATION', $__LANG->get('date_of_creation'));
	$view	->	assign('DATE_OF_DEADLINE', $__LANG->get('date_of_deadline'));	
	
	$view	->	assign('WRITE', $__LANG->get('write'));
	$view	->	assign('RESET', $__LANG->get('reset'));
	$view	->	assign('CANCEL', $__LANG->get('cancel'));
	$view	->	assign('BACKTO', 'loader.php?cat=section&amp;id=production');

	$view	->	display();

?>