<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag order to stock change
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	check_year_for_write('orders_to_stock');

	pagepermission('orders', 'w');

	if (isset($_GET['id']))		{

		$ORDER2STOCKID = $_SESSION['ID'] = $_GET['id'];

	}	else	  {

		$ORDER2STOCKID = $_SESSION['ID'];
	}
	
	if ((! isset($_GET['p_err'])) && isset($_SESSION['_POST_ERR'])) unset($_SESSION['_POST_ERR']);

	load_c('SQL');

	$__SQL 	= new SQL;

	if (isset($_POST['submit']))	{

		load_m('order2stockchange');

		$__ORDER2STOCK	= new ORDER2STOCKCHANGE;

		$RESULT		=	$__ORDER2STOCK->update($ORDER2STOCKID, $_POST);

		unset($__ORDER2STOCK, $__SQL);

		if ($RESULT===TRUE)	{

			$view	=	new View('sucessbox');
			$view	->	assign('SELF', backward());
			$view	->	assign('MESSAGE', $__LANG->get('datawritten'));
			$view	->	assign('OK', $__LANG->get('ok'));
			$view	->	assign('BACKTO', $_SESSION['FROM']);
			$view	->	display();
			exit;
		}

		# analize error type

		if (strpos($RESULT, '->') !== FALSE)	{

			list ($errtype, $point, $pointID)	= explode('->', $RESULT);

			$ERROR	=	$__LANG->get($errtype, $__LANG->get($point).': '.$pointID);

		}	else	 {

			$ERROR	= $__LANG->get($RESULT);
		}
		
		$_POST['_err_address'] = backward();
		
		$_SESSION['_POST_ERR'] = $_POST;

		$view	=	new View('errorbox');
		$view	->	assign('SELF', $_POST['_err_address'].'&amp;p_err=1');
		$view	->	assign('ERROR', $__LANG->get('error'));
		$view	->	assign('ERRTXT', $ERROR);
		$view	->	assign('BACK', $__LANG->get('back'));
		$view	->	display();
		exit;
	}

	# read order data

	if (post_data_verified())	{

		$_POST = enc_quotes($_SESSION['_POST_ERR']);

		unset($_SESSION['_POST_ERR']);

	}	else	  {

		load_m('order2stockread');

		$__ORDER2STOCK	=	new	ORDER2STOCKREAD();
		$_POST		=	$__ORDER2STOCK->read($ORDER2STOCKID);

		unset($__ORDER2STOCK);

		if (! is_array($_POST))		{

			$view	=	new View('errorbox');
			$view	->	assign('SELF',  $_SESSION['FROM']);
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get($_POST));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}
	}

	$view	=	new View('order2stock');

	$view	->	assign('SELF', backward());
	$view	->	assign('CANNOTREMOVE', $__LANG->get('cannotremoverow'));
	$view	->	assign('ORDER2STOCKLABEL', $__LANG->get('order2stockchange', $ORDER2STOCKID.'/'.$_POST['order2stock_year']));
	$view	->	assign('ORDER2STOCKID', $ORDER2STOCKID);
	$view	->	assign('CONTACTNAME', $__LANG->get('contactname'));
	$view	->	assign('COUNTRY', $__LANG->get('country'));
	$view	->	assign('CITY', $__LANG->get('city'));
	$view	->	assign('ZIP', $__LANG->get('zip'));
	$view	->	assign('STREET', $__LANG->get('street'));
	$view	->	assign('DATE_OF_ORDER', $__LANG->get('date_of_order'));
	$view	->	assign('CONNECTED_WITH_ORDERS', $__LANG->get('connected_with_short'));
	$view	->	assign('COMMENT', $__LANG->get('comment'));
	$view	->	assign('COLUMNCODE', $__LANG->get('columnname_code'));
	$view	->	assign('COLUMNNAME', $__LANG->get('columnname_name'));
	$view	->	assign('COLUMNQUANTITY', $__LANG->get('columnname_quantity'));
	$view	->	assign('COLUMNUNIT', $__LANG->get('columnname_unit'));
	$view	->	assign('WRITE', $__LANG->get('write'));
	$view	->	assign('RESET', $__LANG->get('reset'));
	$view	->	assign('BACKTO', $_SESSION['FROM']);
	$view	->	assign('CANCEL', $__LANG->get('cancel'));

	unset($__SQL);

	$view	->	display();

?>
