<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag settings add, change or delete payment form
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	pagepermission('settings', 'w');
	
	check_for_backup_in_progress('settings');

	if (	(isset($_POST['addnew'])) or 
		(isset($_POST['change'])) or 
		(isset($_POST['delete'])) or
		(isset($_POST['default'])))	{

		$SUBMITTED	=	base64_encode(serialize($_POST));

		# note: store submitted data tamporary as id

		$view	=	new View('verify');
		$view	->	assign('SELF', backward());
		$view	->	assign('QUESTION', $__LANG->get('suretochangepayment'));
		$view	->	assign('YES', $__LANG->get('yes'));
		$view	->	assign('NO', $__LANG->get('no'));
		$view	->	assign('ID', $SUBMITTED);
		$view	->	assign('BACKTO', backward());
		$view	->	display();

		exit;
	}
	
	load_c('SQL');

	$__SQL	= new SQL();

	if (isset($_POST['YES']))	{

		load_m('paymentforms');

		$__PAYMENTS	=	new PAYMENTFORMS();

		$SUBMITTED	=	unserialize(base64_decode($_POST['id']));

		if (isset($SUBMITTED['addnew']))	{

			$RESULT	= $__PAYMENTS->addnew($SUBMITTED['newtext'], $SUBMITTED['expected_after_days']);

		}	elseif (isset($SUBMITTED['change']))	{

			$RESULT = $__PAYMENTS->change($SUBMITTED['paymentID'], $SUBMITTED['newtext'], $SUBMITTED['expected_after_days']);

		}	elseif (isset($SUBMITTED['default']))	{

			$RESULT = $__PAYMENTS->defaultpayment($SUBMITTED['paymentID']);

		}	else	{

			$RESULT = $__PAYMENTS->delete($SUBMITTED['paymentID']);
		}

		unset($__PAYMENTS);

		if ($RESULT !== TRUE)	{

			$view	=	new View('errorbox');
			$view	->	assign('SELF', backward());
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get($RESULT));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}

		# reload the payments for all users
		# note: load($RELOAD = TRUE);
		
		$__PAYMENTS	=	new PAYMENTloader($__CONF->get('cache', 'use_apc_cache'), TRUE);
		
		unset($__PAYMENTS);

		$view	=	new View('sucessbox');
		$view	->	assign('SELF', backward());
		$view	->	assign('MESSAGE', $__LANG->get('settingssaved'));
		$view	->	assign('OK', $__LANG->get('ok'));
		$view	->	assign('BACKTO', backward());
		$view	->	display();
		exit;
	}

	$__PAYMENTS	=	new PAYMENTloader($__CONF->get('cache', 'use_apc_cache'));

	$PAYMENT_FORMS		=	$__PAYMENTS->getnames();
	$EXPECTED_DAYS		=	$__PAYMENTS->getvalues();

	unset($__PAYMENTS);

	$view	=	new View('payment_forms');

	$view	->	assign('SELF', backward());
	$view	->	assign('PAYMENT_FORMS', $__LANG->get('payment_forms'));
	$view	->	assign('PAYMENT_FORM', $__LANG->get('payment_name'));
	$view	->	assign('EXPECTED_AFTER_DAYS', $__LANG->get('expected_after_days'));
	$view	->	assign('NEW_NAME', $__LANG->get('newname'));
	$view	->	assign('SET_TO_DEFAULT', $__LANG->get('set_to_default'));
	$view	->	assign('ADDNEW', $__LANG->get('addnew'));
	$view	->	assign('CHANGE', $__LANG->get('change'));
	$view	->	assign('DELETE', $__LANG->get('delete'));
	$view	->	assign('CANCEL', $__LANG->get('cancel'));
	$view	->	assign('BACKTO', 'loader.php?cat=section&amp;id=settings');

	$view	->	assign('PAYMENTS', $PAYMENT_FORMS);
	$view	->	assign('EXPECTEDDAYS', $EXPECTED_DAYS); unset($PAYMENT_FORMS, $EXPECTED_DAYS, $__SQL);

	$view	->	display();

?>
