<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag customer payments change
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	check_year_for_write('payments');

	pagepermission('payments', 'w');

	if (isset($_GET['id']))		{

		$PAYMENT_ID = $_SESSION['ID'] = $_GET['id'];
		
		unset($_SESSION['_POST_ERR']);

	}	else	  {

		$PAYMENT_ID = $_SESSION['ID'];
	}

	load_c('SQL');

	$__SQL	= new SQL();

	if (isset($_POST['submit']))	{

		load_m('paymentchange');
	
		$__PAYMENT 	=	new PAYMENTCHANGE();

		$RESULT		=	$__PAYMENT->change($PAYMENT_ID, $_POST);

		if ($RESULT !== TRUE)	{
		
			$_POST['_err_address'] = backward();

			$_SESSION['_POST_ERR'] = $_POST;

			$view	=	new View('errorbox');
			$view	->	assign('SELF', $_POST['_err_address']);
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get($RESULT));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}

		$view	=	new View('sucessbox');
		$view	->	assign('SELF', backward());
		$view	->	assign('MESSAGE', $__LANG->get('datawritten'));
		$view	->	assign('OK', $__LANG->get('ok'));
		$view	->	assign('BACKTO', $_SESSION['FROM']);
		$view	->	display();
		exit;
	}


	load_m('customers2payread');

	$__CUSTOMERS	=	new CUSTOMERSREAD();

	$CUSTOMERS	=	$__CUSTOMERS->read();

	unset($__CUSTOMERS);

	if (! $CUSTOMERS)	{

		$view	=	new View('errorbox');
		$view	->	assign('SELF', backward());
		$view	->	assign('ERROR', $__LANG->get('error'));
		$view	->	assign('ERRTXT', $__LANG->get('nocustomers2pay'));
		$view	->	assign('BACK', $__LANG->get('back'));
		$view	->	display();
		exit;
	}

	$view	=	new View('payment');

	$view	->	assign('SELF', backward());
	$view	->	assign('LABEL', $__LANG->get('paymentchange', $PAYMENT_ID));
	$view	->	assign('CUSTOMER', $__LANG->get('customer'));
	$view	->	assign('PAYMENTID', $__LANG->get('paymentID'));
	$view	->	assign('DATE', $__LANG->get('date'));
	$view	->	assign('SUM', $__LANG->get('amount').' ('.$__CONF->get('payments', 'currency').') ');
	$view	->	assign('BANK', $__LANG->get('bank'));
	$view	->	assign('ACCOUNT', $__LANG->get('account'));
	$view	->	assign('COMMENT', $__LANG->get('comment'));
	$view	->	assign('WRITE', $__LANG->get('write'));
	$view	->	assign('RESET', $__LANG->get('reset'));
	$view	->	assign('CANCEL', $__LANG->get('cancel'));
	$view	->	assign('BACKTO', $_SESSION['FROM']);

	# form data

	$view	->	assign('CUSTOMERS', $CUSTOMERS);

	if (post_data_verified())	{

		$_POST = enc_quotes($_SESSION['_POST_ERR']); 
		
		unset($_SESSION['_POST_ERR']);

	}	else	  {

		load_m('paymentread');

		$__PAYMENT	=	new PAYMENTREAD();

		$_POST	 	=	$__PAYMENT->read($PAYMENT_ID);

		unset($__PAYMENT);

		if (! $_POST)	{

			$view	=	new View('errorbox');
			$view	->	assign('SELF', backward());
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get('unexistentpayment'));
			$view	->	assign('BACK', $_SESSION['FROM']);
			$view	->	display();
			exit;
		}
	}

	unset($__SQL);
	
	$view	->	display();

?>
