<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag payments statistic for customer
	 */
	 
	if (! defined('eBag'))	{
	
		include('../views/logout.php'); 
	      
		exit();
	}

	pagepermission('payments', 'r');

	if (isset($_GET['new'])) 	{

		$_SESSION['LISTPAGE'] = 0;

		unset($_SESSION['customerID'], $_SESSION['COMMAND'], $_SESSION['LIMIT']);
	}

	load_c('SQL');

	$__SQL	= new SQL();

	if (isset($_POST['selected']))	$_SESSION['customerID'] = $_POST['contactID'];

	if (isset($_SESSION['customerID']))	{

		$_SESSION['FROM'] = backward();

		load_c('PAYMENTSTATISTICS');

		$__PAYMENTS	=	new PAYMENTSTATISTICS(PAGEINCREMENT, $_SESSION['list_limit']);

		$__PAYMENTS	->	customerID($_SESSION['customerID']);

		if (! $__PAYMENTS	->	create())	{

			$view	=	new View('errorbox');
			$view	->	assign('SELF', 'loader.php?cat=section&amp;id=payments');
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get('unexistentcontact'));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}

		$SUMMARY	=	&$__PAYMENTS->SUMMARY;

		$HTMLTABLE	=	&$__PAYMENTS->TABLE;

		$view	=	new View('paymentstatisticlist');
		$view 	->	assign('SUMMARY_FOR_CUSTOMER', $__LANG->get('summary2customer'));
		$view 	->	assign('CLAIMS_SUM', $__LANG->get('allclaimssum'));
		$view 	->	assign('PAYMENTS_SUM', $__LANG->get('allpaymentssum'));
		$view 	->	assign('CURRENCY', $__CONF->get('payments', 'currency'));
		$view 	->	assign('HTMLTABLE', $HTMLTABLE); unset($HTMLTABLE);
		$view 	->	assign('SUMMARY', $SUMMARY); unset($SUMMARY, $__PAYMENTS, $__SQL);
		$view 	->	assign('SELF', backward());
		$view	->	display();

		exit;

	}

	# display customer selector

	load_m('customers2payread');

	$__CUSTOMERS	=	new CUSTOMERSREAD();

	$CUSTOMERS	=	$__CUSTOMERS->read();

	unset($__CUSTOMERS, $__SQL);

	if (! $CUSTOMERS)	{

		$view	=	new View('errorbox');
		$view	->	assign('SELF', backward());
		$view	->	assign('ERROR', $__LANG->get('error'));
		$view	->	assign('ERRTXT', $__LANG->get('nocustomers2pay'));
		$view	->	assign('BACK', $__LANG->get('back'));
		$view	->	display();
		exit;
	}

	$view	=	new View('customerselect');

	$view	->	assign('SELF', backward());
	$view	->	assign('LABEL', $__LANG->get('selectcustomer'));
	$view	->	assign('CUSTOMER', $__LANG->get('customer'));
	$view	->	assign('OK', $__LANG->get('ok'));
	$view	->	assign('RESET', $__LANG->get('reset'));
	$view	->	assign('CANCEL', $__LANG->get('cancel'));
	$view	->	assign('BACKTO', 'loader.php?cat=section&amp;id=payments');

	# form data

	$view	->	assign('CUSTOMERS', $CUSTOMERS);

	$view	->	display();

?>
