<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag production order finished
	 */

	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}
	 
	check_year_for_write('production');

	pagepermission('production', 'w');

	if (isset($_POST['submit']))	{
	
		load_c('SQL');

		$__SQL	= new SQL();
	
		# close production to customers
  
		load_m('productionorderclose');

		$__PRODUCTIONORDER	=	new PRODUCTIONORDERCLOSE();

		$RESULT			=	$__PRODUCTIONORDER->close($_POST);

		unset($__PRODUCTIONORDER, $__SQL);

		if (($RESULT!='opened') && ($RESULT!='closed'))		{

			$view	=	new View('errorbox');
			$view	->	assign('SELF', backward());
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get($RESULT));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();

			exit;
		}

		$view	=	new View('sucessbox');
		$view	->	assign('SELF', backward());
		$view	->	assign('MESSAGE', $__LANG->get('productionorder'.$RESULT, $_POST['productionorderID']));
		$view	->	assign('OK', $__LANG->get('ok'));
		$view	->	assign('BACKTO', backward());
		$view	->	display();

		exit;
	}

	if (isset($_POST['selected']))		{

		if ((! is_empty($_POST['id'])) && ((integer)$_POST['id'] > 0))	{

			load_c('SQL');

			$__SQL	=	new SQL();

			load_m('productionorderclosedefault');

			$__PHASE	=	new PRODUCTIONCLOSEDEFAULT();

			$DATA		=	$__PHASE->read($_POST['id']);

			unset($__PHASE, $__SQL);

			if (! is_array($DATA))	{

				$view	=	new View('errorbox');
				$view	->	assign('SELF', backward());
				$view	->	assign('ERROR', $__LANG->get('error'));
				$view	->	assign('ERRTXT', $__LANG->get('unexistentproductionorder'));
				$view	->	assign('BACK', $__LANG->get('back'));
				$view	->	display();
				exit;
			}

			# display production order close form

			$view	=	new View('productionorderclose');

			$view	->	assign('PRODUCTION_ORDER_CLOSE', $__LANG->get('productionorderclose'));
			$view	->	assign('PERSONID', $__LANG->get('personIDlong'));
			$view	->	assign('CODE', $__LANG->get('code'));
			$view	->	assign('ARTICALNAME', $__LANG->get('articalname'));
			$view	->	assign('QUANTITY', $__LANG->get('quantity'));
			$view	->	assign('CUSTOMER', $__LANG->get('customer'));
			$view	->	assign('DATE_OF_CREATION', $__LANG->get('date_of_creation'));
			$view	->	assign('DATE_OF_FINISHING', $__LANG->get('date_of_finishing'));
			$view	->	assign('DEFECTIVE_QUANTITY', $__LANG->get('defective_quantity'));
			$view	->	assign('NOTICE', $__LANG->get('emptyreopensproduction'));
			$view	->	assign('AUTO_FINISH', $__LANG->get('autofinish'));
			$view	->	assign('WRITE', $__LANG->get('write'));
			$view	->	assign('RESET', $__LANG->get('reset'));
			$view	->	assign('CANCEL', $__LANG->get('cancel'));
			$view	->	assign('BACKTO', backward());

			# form data

			$view	->	assign('DATA', $DATA); unset($DATA);

			$view	->	display();

			exit;
		}
	}	

	# display selector

	$view	=	new View('listselector');

	$view 	->	assign('SELF', backward());
	$view 	->	assign('SELECTLABEL', $__LANG->get('productionorderselect'));
	$view 	->	assign('SELECTEDID', $__LANG->get('productionorderbynumber'));
	$view	->	assign('BACKTO', 'loader.php?cat=section&amp;id=production');
	$view 	->	assign('OK', $__LANG->get('ok'));
	$view 	->	assign('RESET', $__LANG->get('reset'));
	$view 	->	assign('CANCEL', $__LANG->get('cancel'));

	$view	->	display();

?>
