<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag production orders search
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	pagepermission('production', 'r');

	# Delete previous search data

	if (isset($_GET['new']))	{

		$_SESSION['LISTPAGE']	=	0;

		if (isset($_SESSION['COMMAND'])) unset($_SESSION['COMMAND'], $_SESSION['LIMIT']);

		unset($_GET['new']);
	}

	load_c('SQL');

	$__SQL	= new SQL();

	# Display founds

	if (	(isset($_POST['submit'])) or 
		(isset($_SESSION['COMMAND']))	)		{

			unset($_POST['submit']);

			load_c('SEARCH');

			$search		=	new SEARCH($_SESSION['BASE'].'.production_orders_header', $_GET['cat'], 'productionorderdetails', 'productionorderchange', 'productionorderdelete', PAGEINCREMENT, $_SESSION['list_limit']);
			$COLUMNS	=	array('personID', 'code', 'articalname', 'contactname', 'orderID', 'date_of_deadline', 'finished', 'production_phase');

			$search		->	column($COLUMNS);

			if (! isset($_POST)) $_POST=array();

			if ($search->addsearch($_POST)); unset($_POST);

			$_SESSION['FROM']	=	backward();

			if ($search->create())	{

				$HTMLTABLE	=	&$search->TABLE;

				$view	=	new View('tablesearch');
				$view 	->	assign('HTMLTABLE', $HTMLTABLE); unset($HTMLTABLE, $search, $__SQL);
				$view 	->	assign('SELF', backward());
				$view 	->	assign('FOCUS', 'NEW');				
				$view	->	display();
				exit;
			}

			$view	=	new View('errorbox');
			$view	->	assign('SELF', backward());
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get('nothingtosearch'));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
	}

	$view	=	new View('productionorderssearch');

	$view	->	assign('SELF', backward());
	$view	->	assign('PRODUCTION_ORDERS_SEARCH', $__LANG->get('productionordersearch'));
	$view	->	assign('PERSONID', $__LANG->get('personIDlong'));
	$view	->	assign('CODE', $__LANG->get('code'));
	$view	->	assign('ARTICALNAME', $__LANG->get('articalname'));
	$view	->	assign('QUANTITY', $__LANG->get('quantity'));
	$view	->	assign('CUSTOMER', $__LANG->get('customer'));
	$view	->	assign('PRODUCTION_TYPE', $__LANG->get('productiontype'));
	$view	->	assign('ORDERED', $__LANG->get('orderedtype'));
	$view	->	assign('INTERNAL', $__LANG->get('internaltype'));
	$view	->	assign('CONNECTED_WITH_ORDER', $__LANG->get('connectedwithorder'));
	$view	->	assign('DATE_OF_CREATION', $__LANG->get('date_of_creation'));
	$view	->	assign('DATE_OF_DEADLINE', $__LANG->get('date_of_deadline'));
	$view	->	assign('FINISHED', $__LANG->get('finished'));
	$view	->	assign('PRODUCTION_PHASE', $__LANG->get('production_phase'));
	$view	->	assign('DATE_OF_FINISHING', $__LANG->get('date_of_finishing'));
	$view	->	assign('FINISHER', $__LANG->get('finisher'));
	$view	->	assign('TECHNOLOGY', $__LANG->get('technology'));
	$view	->	assign('DRAWINGID', $__LANG->get('drawingnumber'));
	$view	->	assign('FEEDSTOCK_CODE', $__LANG->get('feedstockcode'));
	$view	->	assign('FEEDSTOCK_QUANTITY', $__LANG->get('feedstockquantity'));
	$view	->	assign('YES', $__LANG->get('yes'));
	$view	->	assign('NO', $__LANG->get('no'));
	$view	->	assign('SEARCH', $__LANG->get('search'));
	$view	->	assign('CANCEL', $__LANG->get('cancel'));
	$view	->	assign('RESET', $__LANG->get('reset'));
	$view	->	assign('BACKTO', 'loader.php?cat=section&amp;id=production');

	$ELEMENTS	=	array ('!=0'=>'!=0', '=0'=>'=0', '<0'=>'&lt;0', '<10'=>'&lt;10', '<50'=>'&lt;50', '<100'=>'&lt;100', '<500'=>'&lt;500', '<1000'=>'&lt;1000');

	$view	->	assign('ELEMENT', $ELEMENTS); unset($ELEMENTS);

	$__PHASES	=	new PHASEloader($__CONF->get('cache', 'use_apc_cache'));

	$PHASES		=	$__PHASES->getall();

	unset($__PHASES);

	$view	->	assign('PHASES', $PHASES); unset($PHASES);

	$view	->	display();
?>
