<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag service delete by number & code
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	check_year_for_write('services');

	pagepermission('services', 'w');

	# verifyed delete it

	if (isset($_POST['YES']))	{

		load_c('SQL');

		$__SQL	= new SQL();

		load_m('servicedelete');

		$__SERVICE = new SERVICEDELETE();

		$RESULT	= $__SERVICE->delete($_POST['id']);

		unset($__SERVICE, $__SQL);

		if ($RESULT !== TRUE)	{

			# analize error type

			if (strpos($RESULT, '->') !== FALSE)	{

				list ($errtype, $point, $pointID) = explode('->', $RESULT);

				$ERROR	=	$__LANG->get($errtype, $__LANG->get($point).': '.$pointID);

			}	else	 {

				$ERROR	= $__LANG->get($RESULT);
			}

			$view	=	new View('errorbox');
			$view	->	assign('SELF', $_SESSION['FROM']);
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $ERROR);
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}

		$view	=	new View('sucessbox');
		$view	->	assign('SELF', backward());
		$view	->	assign('MESSAGE', $__LANG->get('servicedeleted', $_POST['id']));
		$view	->	assign('OK', $__LANG->get('ok'));
		$view	->	assign('BACKTO', $_SESSION['FROM']);
		$view	->	display();
		exit;
	}

	# choose service form
	
	if (! isset($_POST['submit']))	{

		$_SESSION['FROM'] = backward();

		$view	=	new View('stockselector');

		$view 	->	assign('SELF', backward());
		$view 	->	assign('SELECTLABEL', $__LANG->get('serviceselect'));
		$view 	->	assign('SELECTEDID', $__LANG->get('servicebynumber'));
		$view 	->	assign('SELECTEDCODE', $__LANG->get('servicebycode'));
		$view	->	assign('BACKTO', 'loader.php?cat=section&amp;id=services');

		$view 	->	assign('OK', $__LANG->get('ok'));
		$view 	->	assign('RESET', $__LANG->get('reset'));
		$view 	->	assign('CANCEL', $__LANG->get('cancel'));

		$view	->	display();

		exit;
	}

	# input check

	load_c('SQL');

	$__SQL	= new SQL();

	$ID	= $_POST['id'];
	$CODE	= $_POST['code'];
	$TABLE	= 'ebagstock.services';

	load_m('idsearch');

	$search= new IDSEARCH();

	if ((! is_empty($ID)) && (! is_empty($CODE)))	{

		$ID = $search->bycode($TABLE, $CODE);

	}	else	   {

		if (! is_empty($ID))	{

			$CODE = $search->byID($TABLE, $ID);

		}	else	 {

			if (! is_empty($CODE))	$ID = $search->bycode($TABLE, $CODE);
		}
	}
	
	unset($search, $__SQL);

	if ((! $ID) or (! $CODE)) 	{

		# bad input

		$view	=	new View('errorbox');
		$view	->	assign('SELF', backward());
		$view	->	assign('ERROR', $__LANG->get('error'));
		$view	->	assign('ERRTXT', $__LANG->get('servicenotmatch'));
		$view	->	assign('BACK', $__LANG->get('back'));
		$view	->	display();
		exit;
	}

	# verify

	$view	=	new View('verify');
	$view	->	assign('SELF', backward());
	$view	->	assign('QUESTION', $__LANG->get('suretodelservice', $ID.' ('.$__LANG->get('code').': '.$CODE.')'));
	$view	->	assign('YES', $__LANG->get('yes'));
	$view	->	assign('NO', $__LANG->get('no'));
	$view	->	assign('ID', $ID);
	$view	->	assign('BACKTO', backward());
	$view	->	display();

?>
