<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 5.0.0
	 */

	/**
	 * eBag years administration
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	pagepermission('settings', 'w');
	
	check_for_backup_in_progress('settings');

	if (	(((isset($_POST['close'])) or (isset($_POST['open']))) && ($_POST['year'])) or
		(isset($_POST['create']))	)	{

		$SUBMITTED	=	base64_encode(serialize($_POST));

		if (isset($_POST['close']))	{

			$ACTION = 'close';
	
			$YEAR	=	$_POST['year'];

		}	elseif (isset($_POST['open']))	{

			$ACTION = 'open';

			$YEAR	=	$_POST['year'];

		}	else	  {

			$ACTION = 'create';

			$YEAR	=	date("Y");
		}

		# note: store submitted data temporary as id

		$view	=	new View('verify');
		$view	->	assign('SELF', backward());
		$view	->	assign('QUESTION', $__LANG->get('sureto'.$ACTION.'year')." $YEAR ?");
		$view	->	assign('YES', $__LANG->get('yes'));
		$view	->	assign('NO', $__LANG->get('no'));
		$view	->	assign('ID', $SUBMITTED);
		$view	->	assign('BACKTO', backward());
		$view	->	display();

		exit;		
	}

	load_c('SQL');

	$__SQL	= new SQL();

	
	if (isset($_POST['YES']))	{

		$SUBMITTED	=	unserialize(base64_decode($_POST['id']));

		load_c('YEARSADMIN');

		$__YEAR	=	new YEARSADMIN();
		
		$__YEAR->backupdir($__CONF->get('backup', 'directory'));

		if (isset($SUBMITTED['close']))	{

			$RESULT	= $__YEAR->close($SUBMITTED['year']);

		} elseif (isset($SUBMITTED['open']))	{

			$RESULT	= $__YEAR->open($SUBMITTED['year']);

		}	else 	  {

			$SUBMITTED['year'] = date("Y");

			$RESULT = $__YEAR->create_new($SUBMITTED['year']);
		}

		unset($__YEAR, $__SQL);

		# analize result

		if (strpos($RESULT, '->') !== FALSE)	{

			list ($error, $message) = explode('->', $RESULT);

			$ERROR	=	$__LANG->get($message);

			$view	=	new View('errorbox');
			$view	->	assign('SELF', backward());
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $ERROR);
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}

		$view	=	new View('sucessbox');
		$view	->	assign('SELF', backward());
		$view	->	assign('MESSAGE', $__LANG->get($RESULT, $SUBMITTED['year']));
		$view	->	assign('OK', $__LANG->get('ok'));
		$view	->	assign('BACKTO', backward());
		$view	->	display();
		exit;
	}

	load_m('yearlist2administration');

	$__YEARS = new YEARLIST();

	$YEARS = $__YEARS->getlist();

	unset($__YEARS, $__SQL);

	if (! $YEARS)	{

		$view	=	new View('errorbox');
		$view	->	assign('SELF', 'loader.php?cat=section&amp;id=settings');
		$view	->	assign('ERROR', $__LANG->get('error'));
		$view	->	assign('ERRTXT', $__LANG->get('fatalerror'));
		$view	->	assign('BACK', $__LANG->get('back'));
		$view	->	display();
		exit;
	}

	load_f('mb_wrap');

	$view	=	new View('years');

	$view	->	assign('SELF', backward());
	$view	->	assign('YEAR_ADMINISTRATION', $__LANG->get('yearadministration'));
	$view	->	assign('EXISTS_YEARS', $__LANG->get('existyears'));
	$view	->	assign('WARNING', mb_wrap($__LANG->get('yearswarning'), 50, '<br>'));
	$view	->	assign('CLOSE', $__LANG->get('close'));
	$view	->	assign('OPEN', $__LANG->get('open'));
	$view	->	assign('CREATE', $__LANG->get('create'));
	$view	->	assign('CANCEL', $__LANG->get('cancel'));
	$view	->	assign('BACKTO', 'loader.php?cat=section&amp;id=settings');
		
	$view	->	assign('YEARS', $YEARS);
	
	$view	->	display();

?>
