<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 2.0.1
	 */

	/**
	 * Converts date to search format d/m/y
	 * note: signs are defined in lang file
	 */

	function date2search($DATE, $DAYSIGN, $MONTHSIGN, $YEARSIGN)	{

		$DATE	=	strtolower($DATE);

		$len	=	strlen($DATE);

		$marks	=	array($DAYSIGN=>'d', $MONTHSIGN=>'m', $YEARSIGN=>'y');

		$date	=	array();

		for ($i=0; $i<$len; $i++)	{

			$char = substr($DATE, $i, 1);

			if (array_key_exists($char, $marks))	{

				$key 		=	$marks[$char];
				$date[$key]	=	'';
				continue;

			}	else	{

				if (! $i)	{

					$key		=	'd';
					$date[$key]	=	$char;
					continue;
				}
			}

			$date[$key] .= $char;
		}

		foreach ($marks as $key=>$mark)	  {

			if (! isset($date[$mark]))	{

				$date[$mark]='-';

			}	else	{

				$date[$mark]=(integer)$date[$mark];

			}
		}
		
		return $date['d'].'/'.$date['m'].'/'.$date['y'];
	}

?>
