	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * Read data & fill phase bonuses form
	 */

	// Show-hide the rows with article inputs
	
	function show_rows(field)	{
	  
		var rowclass, position;
		
		position = document.getElementById('setting_type').value;
		 
		if (position == '2')	{
		  
			rowclass = 'row-show';
		  
		}	else	  {
		    
			rowclass = 'row-hide';
		}
		 
		for (i=1; i<4; i++) {
		  
			document.getElementById('datarow' + i).className = rowclass;
		}
		
		reset_form('setting_type');
	}
	
	// Modified to handle hidden fields
	
	function nextfield(field, event, target)	{

		var code = event.keyCode ? event.keyCode : event.which ? event.which : event.charCode;
		
		var rowclass = document.getElementById('datarow1').className;
		
		if ((target == 'stock_id') && (rowclass == 'row-hide')) target = 'bonus_type';
		
		var target_field = document.getElementById(target);

		if ((code == 13) && (target_field != null))	{

			target_field.focus();

			return false;
		}

		return true;
	}

	function reset_form(exept)	{
	  
		var count;
	  
		var inputs = document.forms[0].getElementsByTagName("input");
		
		count = inputs.length;

		for (i=0; i<count; i++) {
		  
			inputs[i].value = inputs[i].defaultValue;
		}
		
		var selects = document.forms[0].getElementsByTagName("select");
		
		count = selects.length;

		for (i=0; i<count; i++) {
		    
			if (selects[i].name == exept) continue;
		  
			selects[i].selectedIndex = 0;
		}
	}
	
	// Form fields handler
	
	var Field = function () {
	  
		var Names = [	"employee_id", "setting_type", "stock_id", "code", "item_name", "bonus_type", "phase_id", "bonus_value", 
				"status_message", "not_found_msg", "set_msg", "unset_msg", "invalid_bonus_msg", "not_product_msg"];
		var i;
		
		for (i=0; i<14; i++) {
		  
			this[Names[i]] = document.getElementById(Names[i]);
		}
	};
	
	// Data read & form fill
	
	function bonus_data_read(call) {
	  
		var i, key, xmlData, message, getValue;
	  
		var Fields 	=	new Field();
	  
		var xmlHttp	=	createXmlHttpRequestObject();

		xmlHttp.onreadystatechange=function()	{

			if (xmlHttp.readyState==4 && xmlHttp.status==200)	{

				if (xmlHttp.responseText)	{

					message = '';

					if (xmlHttp.responseText == '1')	{
					  
						reset_form('setting_type'); 
						
						Fields.stock_id.focus();
						
						message = Fields.not_found_msg.value;
					}
					
					if (xmlHttp.responseText == '2')	{
					  
						message = Fields.not_product_msg.value;
					}
					
					if (message)	{
					  
						Fields.status_message.innerHTML = message;
						
						setTimeout(function(){Fields.status_message.innerHTML = "&nbsp;";}, 600);
						
						return;
					}
					
					if ((xmlHttp.responseXML == null) || (typeof xmlHttp.responseXML == 'undefined')) return;
					
					var xmlDoc = xmlHttp.responseXML;
					
					var Requesteds = ["stock_id", "code", "item_name", "bonus_value"];
					
					for (i=0; i<4; i++) {
			
						  xmlData = xmlDoc.getElementsByTagName(Requesteds[i]);
						  
						  getValue = '';

						  if ((xmlData[0].childNodes[0] != null) && (typeof xmlData[0].childNodes[0] != 'undefined')) {

							    getValue = xmlData[0].childNodes[0].nodeValue;
						  }
						  
						  if (((call.name == 'stock_id') || (call.name == 'code')) && (call.name == Requesteds[i])) {continue;}
						  
						  Fields[Requesteds[i]].value = getValue;
					}
				}
	    		}
	  	}
	  	
		if ((call.name != 'stock_id') && (call.name != 'code') && (Fields.phase_id.value == 'none')) {Fields.bonus_value.value=''; return;}
	  	
	  	if (Fields.setting_type.value == 1)	{
		  
			Names = ["employee_id", "setting_type", "bonus_type", "phase_id"];
			
		}	else	  {
		  
			Names = ["employee_id", "setting_type", "bonus_type", "phase_id", "stock_id", "code"];
		
			if ((! Fields.stock_id.value) && (! Fields.code.value)) return;
		}
		
		var postvalues = '';
		
		count = Names.length;

		for (i=0; i<count; i++) {

			FieldValue = Fields[Names[i]].value;

			if (FieldValue)	{

				if (postvalues) {postvalues += '&';}

				postvalues += Names[i] + '=' + encodeURIComponent(FieldValue);
			}
		}
		
		if (! postvalues) return;
		
		if ((call.name == 'stock_id') || (call.name == 'code')) postvalues += '&call=' + call.name;

		xmlHttp.open('POST', '../requests/bonusphaseread.php', true);
		
		xmlHttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		xmlHttp.setRequestHeader("Content-length", postvalues.length);
		xmlHttp.setRequestHeader("Connection", "close");

		xmlHttp.send(postvalues);
	}
	
	
	function bonus_data_write()	{
	  
		var i, key, message, Names, count;
		
		var Msg		=	["set_msg", "unset_msg", "not_found_msg", "invalid_bonus_msg", "not_product_msg"];
	  
		var Fields 	=	new Field();
	  
		var xmlHttp	=	createXmlHttpRequestObject();
		
		xmlHttp.onreadystatechange=function()	{

			if (xmlHttp.readyState==4 && xmlHttp.status==200)	{

				if (xmlHttp.responseText)	{

					key = Number(xmlHttp.responseText) - 1;
					
					message = '';
					
					if (typeof Msg[key] != 'undefined')	{

						message = Fields[Msg[key]].value;
					}
					
					Fields.status_message.innerHTML = message;
					
					setTimeout(function(){Fields.status_message.innerHTML = "&nbsp;";}, 600);
				}
	    		}
	  	}
	  	
		if (Fields.phase_id.value == 'none') return;
	  	
	  	if (Fields.setting_type.value == 1)	{
		  
			Names = ["employee_id", "setting_type", "bonus_type", "phase_id", "bonus_value"];
			
		}	else	  {
		  
			Names = ["employee_id", "setting_type", "bonus_type", "bonus_value", "phase_id", "stock_id", "code"];
		
			if ((! Fields.stock_id.value) && (! Fields.code.value)) return;
		}
		
		var postvalues = '';
		
		count = Names.length;

		for (i=0; i<count; i++) {

			FieldValue = Fields[Names[i]].value;

			if (FieldValue)	{

				if (postvalues) {postvalues += '&';}

				postvalues += Names[i] + '=' + encodeURIComponent(FieldValue);
			}
		}
		
		if (! postvalues) return;

		xmlHttp.open('POST', '../requests/bonusphasewrite.php', true);
		
		xmlHttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		xmlHttp.setRequestHeader("Content-length", postvalues.length);
		xmlHttp.setRequestHeader("Connection", "close");

		xmlHttp.send(postvalues);
	}
	