<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag bill to one or more (or all) customer
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class BILL2CUSTOMERS	{
	
		var $contactIDs		=	FALSE;

		var $SERVICESBILL	=	FALSE;

		var $DELIVERYSBILL	=	FALSE;

		var $BILL_ALL		=	FALSE;
		
		var $ONLY2COMPANIES	=	FALSE;

		var $ERROR		=	array();
		
		var $SUCCESS 		=	array();

		function __construct()	{

			global $__SQL, $__LANG, $__CONF;

			$this->SQL		=	&$__SQL;
			
			$this->LANG		=	&$__LANG;

			$this->BASE		=	$_SESSION['BASE'];

			$this->baseyear		=	$_SESSION['year'];
	
			$__PAYMENTS		=	new PAYMENTloader($__CONF->get('cache', 'use_apc_cache'));

			$this->EXPECTED_DAYS_TO_PAY	=	$__PAYMENTS->getvalues();

			unset($__PAYMENTS);

			if (! $this->EXPECTED_DAYS_TO_PAY) exit($__LANG->get('fatalerror'));
		}

		public function bill2all()	{

			$this->BILL_ALL		=	TRUE;
		}
		
		public function only2companies()	{
		
			$this->ONLY2COMPANIES	=	TRUE;
		}

		public function bill_services()	{

			$this->SERVICESBILL	=	TRUE;
		}

		public function bill_deliverys() {

			$this->DELIVERYSBILL	=	TRUE;
		}

		public function addcustomers($IDs=FALSE)	{

			if (! $IDs) return;

			if (! is_array($IDs))	{

				$this->contactIDs = array($IDs);

			}	else	 {

				$this->contactIDs = $IDs;
			}

			$this->contactIDs 	=	array_unique($this->contactIDs);
		}

		public function getfirstid()		{

			if (isset($this->FIRSTID)) {return $this->FIRSTID;} else {return FALSE;}
		}
		
		public function geterror()	{
		
			return $this->ERROR;
		}
		
		public function getreport()	{
		
			return array_merge($this->SUCCESS, $this->ERROR);
		}

		# read all billable ids for all customers	

		private function read_for_all()		{

			$READ1 = $READ2 = '';

			if ($this->SERVICESBILL)	$READ1 = "	SELECT `contactID`
									FROM $this->BASE.services_header
									WHERE `billID` IS NULL AND `date_of_finishing` IS NOT NULL AND `deleted` IS NOT NULL
									GROUP BY `contactID` ";

			if ($this->DELIVERYSBILL)	$READ2 = "	SELECT `contactID`
									FROM $this->BASE.deliverys_header
									WHERE `billID` IS NULL AND `deleted` IS NOT NULL 
									GROUP BY `contactID` ";

			if ((! $READ1) && (! $READ2))	return;

			if (($this->SERVICESBILL) && ($this->DELIVERYSBILL)) { $COMMAND = " ( $READ1 ) UNION ( $READ2 ) "; } else {  $COMMAND = $READ1.$READ2; }

			$this->SQL->query($COMMAND);

			if (! $this->SQL->num_rows()) return;
			
			$this->contactIDs = array();
			
			$this->SQL->IT1_RESULT = $this->SQL->RESULT;

			while ($IT1_RESULT = $this->SQL->IT1_RESULT->fetch_row())	{
			
				$ID = $IT1_RESULT[0];
			
				if ($this->ONLY2COMPANIES)	{
				
					$this->SQL->query("	SELECT `contactname`
								FROM $this->BASE.addressbook
								WHERE `contacttype`='1' AND `personID`='$ID' LIMIT 1	");
								
					if ($this->SQL->num_rows()) continue;
				    
				}
			
				$this->contactIDs[] = $ID;
			}
			
			# Note: must be false if is empty, after not checks for count
			
			if (! count($this->contactIDs)) $this->contactIDs = FALSE;
		}

		private function lock()		{

			$LOCK = "	LOCK TABLES 	$this->BASE.addressbook WRITE, $this->BASE.bills_header WRITE, $this->BASE.bills_data WRITE, $this->BASE.claims WRITE ";

			if ($this->SERVICESBILL)	{

				$LOCK .= ", $this->BASE.services_header WRITE, $this->BASE.services_data WRITE ";

			}

			if ($this->DELIVERYSBILL) 	{

				$LOCK .= ", $this->BASE.deliverys_header WRITE, $this->BASE.deliverys_data WRITE ";
			}
	
			$this->SQL->query($LOCK);

		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}
		
		function _error($str)	{
		
			if (strpos($str, '->') !== FALSE)	{
		
				list($msg, $id)  = explode('->', $str);
				  
				$this->ERROR[] = $this->LANG->get($msg, $id);
				  
			}	else 	  {
			
				$this->ERROR[] = $this->LANG->get($str);
			}
		}

		# creates new bill by delivery or revers, returns error string or new bill ID

		public function opennewbill($ID, $TABLE)	{

			# note : table is services_header or deliverys_header

			$this->SQL->query("	SELECT 	`companyID`, `contactID`, `contactname`, `account1`, `bank1`, 
							`account2`, `bank2`, `contacttype`, `currency`, `payment_form`
						FROM $this->BASE.$TABLE
						WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

			$RESULT	=	$this->SQL->RESULT->fetch_assoc();

			foreach($RESULT as $key=>$val) $RESULT[$key] = $this->SQL->nr_escape($val);

			extract($RESULT);
			
			# reread the address data from addressbook because of delivery address
		
			$this->SQL->query("	SELECT `country`, `city`, `zip`, `street`
						FROM $this->BASE.addressbook
						WHERE `personID`=$contactID AND `deleted` IS NOT NULL LIMIT 1	");
						
			if (! $this->SQL->num_rows()) return FALSE;

			$RESULT	=	$this->SQL->RESULT->fetch_assoc();

			foreach($RESULT as $key=>$val) $RESULT[$key] = $this->SQL->nr_escape($val);

			extract($RESULT); unset($RESULT);

			if (! isset($this->EXPECTED_DAYS_TO_PAY[str_replace("'", '', $payment_form)])) return FALSE;

			$EXPECTED_PAYMENT = $this->EXPECTED_DAYS_TO_PAY[str_replace("'", '', $payment_form)];

			$now = date("Y-m-d");

			$payment_deadline	=	date("Y-m-d", strtotime($EXPECTED_PAYMENT.' days'));

			$this->SQL->query("	INSERT INTO $this->BASE.bills_header 
						VALUES 
						(NULL, $companyID, $contactID, $contactname, $country, $city, $zip, $street, 
						$account1, $bank1, $account2, $bank2, $contacttype, $currency, $payment_form,
						NULL, NULL, '$now', '$payment_deadline', NULL, NULL, NULL, '0')	");

			$newID	=	$this->SQL->lastid();

			# store the first billID to get it back if need

			if (! isset($this->FIRSTID)) $this->FIRSTID = $newID;

			return $newID;
		}

		# write revers data to bill (not the same with delivery because of prices coefs)

		private function revers2bill($reversID, $billID)	{

			# calculate real price coefs for each revers (deliverys contains the real prices)

			$this->SQL->query("	SELECT 	`exchange_rate`, `service_discount`,  `session_discount`, 
							`use_service_discount`, `use_session_discount`
						FROM $this->BASE.services_header
						WHERE `personID`='$reversID' AND `deleted` IS NOT NULL LIMIT 1	");

			$RESULT	=	$this->SQL->RESULT->fetch_assoc();

			extract($RESULT); unset($RESULT);

			$SESSION_COEF = $SERVICE_COEF = 1;

			if (($use_session_discount) && ($session_discount>0))	$SESSION_COEF = (100-$session_discount) / 100;

			if (($use_service_discount) && ($service_discount>0))	$SERVICE_COEF = (100-$service_discount) / 100;

			$GLOBAL_COEF	=	$SESSION_COEF * $SERVICE_COEF * $exchange_rate;

			# write articles

			$this->SQL->query("	SELECT `personID`, `code`, `servicename`, `quantity`, `unit`, `price`, `tax`
						FROM $this->BASE.services_data
						WHERE `reversID`='$reversID' AND `deleted` IS NOT NULL ORDER BY `personID` ");

			if ($this->SQL->num_rows())	{

				$this->SQL->IT2_RESULT = $this->SQL->RESULT;

				while ($RESULT = $this->SQL->IT2_RESULT->fetch_assoc())		{

					foreach ($RESULT as $key=>$val)	{

						if ($key == 'price')	{

							$RESULT[$key] = $this->SQL->escape($val * $GLOBAL_COEF);

							continue;
						}

						$RESULT[$key] = $this->SQL->nr_escape($val);
					}

					extract($RESULT); unset($RESULT);

					# note: datatype d=>delivery, s=>service

					$this->SQL->query("	INSERT INTO $this->BASE.bills_data
								VALUES 
								(NULL, '$billID', $code, $servicename, $quantity, $unit, $price, $tax, $personID, 's', '0')	");
				}

				unset($this->SQL->IT2_RESULT);
			}

			# update connected with reverses

			$this->SQL->query("	SELECT `connected_with_reverses`
						FROM $this->BASE.bills_header
			  			WHERE 	(`connected_with_reverses` NOT REGEXP '-$reversID-' OR `connected_with_reverses` IS NULL)
							AND `personID`='$billID' AND `deleted` IS NOT NULL LIMIT 1	");

			if ($this->SQL->num_rows())	{

				$RESULT	=	$this->SQL->RESULT->fetch_row();

				if ($connected_with_reverses = $RESULT[0])	{

					$connected_with_reverses	.=	"$reversID-";

				}	else	  {

					$connected_with_reverses	=	"-$reversID-";
				}


				$this->SQL->query("	UPDATE $this->BASE.bills_header
							SET `connected_with_reverses`='$connected_with_reverses'
				  			WHERE `personID`='$billID' AND `deleted` IS NOT NULL LIMIT 1	");
			}

			# update services header set to billed

			$this->SQL->query("	UPDATE $this->BASE.services_header
						SET `billed`='1', `billID`='$billID' 
						WHERE `personID`='$reversID' LIMIT 1	");
		}

		# write delivery data to bill 

		private function delivery2bill($deliveryID, $billID)	{

			# write data

			$this->SQL->query("	SELECT `personID`, `code`, `name`, `quantity`, `unit`, `price`, `tax`
						FROM $this->BASE.deliverys_data
						WHERE `deliveryID`='$deliveryID' AND `deleted` IS NOT NULL ORDER BY `personID` ");

			if ($this->SQL->num_rows())	{

				$this->SQL->IT2_RESULT	=  $this->SQL->RESULT;

				while ($RESULT = $this->SQL->IT2_RESULT->fetch_assoc())	{

					foreach ($RESULT as $key=>$val) $RESULT[$key] = $this->SQL->nr_escape($val);

					extract($RESULT); unset($RESULT);

					# note: datatype d=>delivery, s=>service

					$this->SQL->query("	INSERT INTO $this->BASE.bills_data
								VALUES
								(NULL, '$billID', $code, $name, $quantity, $unit, $price, $tax, $personID, 'd', '0')	");
				}

				unset($this->SQL->IT2_RESULT);
			}

			# update connected with deliverys

			$this->SQL->query("	SELECT `connected_with_deliverys` 
						FROM $this->BASE.bills_header
		 	 			WHERE 	(`connected_with_deliverys` NOT REGEXP '-$deliveryID-' OR `connected_with_deliverys` IS NULL) 
							AND `personID`='$billID' AND `deleted` IS NOT NULL LIMIT 1	");

			if ($this->SQL->num_rows())	{

				$RESULT	=	$this->SQL->RESULT->fetch_row();

				if ($connected_with_deliverys = $RESULT[0])	{

					$connected_with_deliverys	.=	"$deliveryID-";

				}	else	  {

					$connected_with_deliverys	=	"-$deliveryID-";
				}

				$this->SQL->query("	UPDATE $this->BASE.bills_header
							SET `connected_with_deliverys`='$connected_with_deliverys'
							WHERE `personID`='$billID' AND `deleted` IS NOT NULL LIMIT 1	");
			}

			# update deliverys header set to billed

			$this->SQL->query("	UPDATE $this->BASE.deliverys_header
						SET `billed`='1', `billID`='$billID' 
						WHERE `personID`='$deliveryID' LIMIT 1	");
		}
		
		private function rollback_and_report($msg)	{
		
			$this->_error($msg);
					
			$this->SQL->rollback();

			$this->unlock();
			
			usleep(300000);
		}

		public function create()	{
		
			$CREATED = FALSE;
		
			set_time_limit(0);

			if ($this->BILL_ALL) $this->read_for_all();

			if ((! $this->contactIDs) or 
			   ((! $this->SERVICESBILL) && (! $this->DELIVERYSBILL)))  {

				if (($this->BILL_ALL) && (! $this->contactIDs))	{$this->_error('nocustomer2billfound'); return FALSE;}

				$this->_error('nothingisselected');
				
				return FALSE;
			}

			foreach ($this->contactIDs as $contactID)	{
			
				$error = FALSE;
			
				$this->SQL->transaction();
		
				$this->lock();
				
				$this->SQL->query("	SELECT `contacttype`, `contactname`
							FROM $this->BASE.addressbook
							WHERE `personID`='$contactID' AND `deleted` IS NOT NULL LIMIT 1	");
							
				if (! $this->SQL->num_rows())	{$this->rollback_and_report("unexistentcustomer->$contactID"); continue;}
				
				list($contacttype, $contactname) = $this->SQL->RESULT->fetch_row();

				if (($this->ONLY2COMPANIES) && ($contacttype == 1)) {$this->rollback_and_report("customerpayswithcash->$contactname"); continue;}

				$OPENEDBILLS	=	array();

				# read reverses to bill

				if ($this->SERVICESBILL)	{

					$this->SQL->query("	SELECT `personID`, `contactname`, `payment_form`
								FROM $this->BASE.services_header
					  			WHERE 	`contactID`='$contactID' AND `billID` IS NULL 
									AND `date_of_finishing` IS NOT NULL AND `deleted` IS NOT NULL	");

					if ($this->SQL->num_rows())	{

						$this->SQL->IT1_RESULT = $this->SQL->RESULT;

						while ($RESULT = $this->SQL->IT1_RESULT->fetch_assoc())		{

							$reversID	=	$RESULT['personID'];

							$contactname	=	$RESULT['contactname'];

							$payment_form	=	$RESULT['payment_form'];
				
							# note: if customer pays with cash this service list step over

							if (! $this->EXPECTED_DAYS_TO_PAY[$payment_form]) continue;

							# check that is opened bill with this payment

							if ((! count($OPENEDBILLS)) or
							    (! isset($OPENEDBILLS[$payment_form])))	{

								# open new one with this revers data

								$billID	= $this->opennewbill($reversID, 'services_header');

								if ($billID === FALSE)	{$error = TRUE; break;}

								$OPENEDBILLS[$payment_form] = $billID;

							}	else	  {

								# append to opened

								$billID	= $OPENEDBILLS[$payment_form];
							}

							# write articles into

							$this->revers2bill($reversID, $billID);
						}

						unset($this->SQL->IT1_RESULT);
					}
					
					if ($error) {$this->rollback_and_report("cannotcreatenewbill->$contactname"); continue;}
				}
				
				# read deliverys to bill

				if ($this->DELIVERYSBILL)	{

					$this->SQL->query("	SELECT `personID`, `contactname`, `payment_form`
								FROM $this->BASE.deliverys_header
								WHERE `contactID`='$contactID' AND `billID` IS NULL AND `deleted` IS NOT NULL	");

					if ($this->SQL->num_rows())	{

						$this->SQL->IT1_RESULT = $this->SQL->RESULT;

						while ($RESULT = $this->SQL->IT1_RESULT->fetch_assoc())		{

							$deliveryID	=	$RESULT['personID'];

							$contactname	=	$RESULT['contactname'];

							$payment_form	=	$RESULT['payment_form'];
				
							# note: if customer pays with cash this service list step over

							if (! $this->EXPECTED_DAYS_TO_PAY[$payment_form]) continue;

							# check that is opened bill with this payment

							if ((! count($OPENEDBILLS)) or
							    (! isset($OPENEDBILLS[$payment_form])))	{

								# open new one with this revers data

								$billID	= $this->opennewbill($deliveryID, 'deliverys_header');

								if ($billID === FALSE) {$error = TRUE; break;}

								$OPENEDBILLS[$payment_form] = $billID;

							}	else	  {

								# append to opened

								$billID	= $OPENEDBILLS[$payment_form];
							}

							# write articles into

							$this->delivery2bill($deliveryID, $billID);
						}

						unset($this->SQL->IT1_RESULT);
					}
					
					if ($error) {$this->rollback_and_report("cannotcreatenewbill->$contactname"); continue;}
				}

				if (count($OPENEDBILLS))	{

					# check for empty's (if nothing is created step over)

					foreach ($OPENEDBILLS as $billID)	{

						$this->SQL->query("	SELECT `personID` 
									FROM $this->BASE.bills_data 
									WHERE `billID`='$billID' AND `deleted` IS NOT NULL LIMIT 1	");

						if (! $this->SQL->num_rows())	{

							$error = TRUE; break;
							
						}	else	{
						
							$this->SUCCESS[] = $this->LANG->get('newbillwritten', $billID)." &lt; $contactname &gt;";
						}
					}
					
					if ($error) {$this->rollback_and_report("cannotcreateemptybill->$contactname"); continue;}
					
					# update claims

					foreach ($OPENEDBILLS as $billID)	{

						$this->SQL->query("	SELECT SUM(price * quantity * ((100 + tax)/100))
									FROM $this->BASE.bills_data WHERE `billID`='$billID' AND `deleted` IS NOT NULL	");

						$RESULT		=	$this->SQL->RESULT->fetch_row();

						$PRICE_SUM_WITH_TAX	=	$RESULT[0];

						$this->SQL->query("	SELECT `contactID`, `contactname`, `city`, `date_of_creation`, `payment_deadline`
									FROM $this->BASE.bills_header
									WHERE `personID`='$billID' AND `deleted` IS NOT NULL LIMIT 1	");

						$RESULT		=	$this->SQL->RESULT->fetch_assoc();

						extract($RESULT);

						# delete old record

						$this->SQL->query("	DELETE FROM $this->BASE.claims
									WHERE `billID`='$billID' AND `baseyear`='$this->baseyear' LIMIT 1	");

						# insert new one

						$this->SQL->query("	INSERT INTO $this->BASE.claims
									VALUES 
									(NULL, '$billID', '$date_of_creation', '$payment_deadline', '$contactID', 
									'$contactname', '$city', '$PRICE_SUM_WITH_TAX', '$this->baseyear', '0')	");
					}
					
				}	else	{
				
					$this->rollback_and_report("cannotcreatenewbill->$contactname"); 
					
					continue;
				}
				
				$this->SQL->commit();

				$this->unlock();
				
				$CREATED = TRUE;
				
				usleep(400000);
			}
			
			return $CREATED;
		}
	}
