<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 5.0.0
	 */

	/**
	 * eBag ordered offer
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class ORDEREDOFFER	{

		var $COPYFROM		=	FALSE;
		var $COPYREPORT		=	FALSE;
		var $offerID		=	FALSE;
		var $ORDER_TO_STOCK	=	FALSE;

		function __construct()	{

			global $__SQL, $__LANG;

			$this->SQL		=	&$__SQL;
			$this->LANG		=	&$__LANG;			
			$this->BASE		=	$_SESSION['BASE'];
			$this->STOCKBASE	=	'ebagstock';
		}

		public function getid()	{

			if (isset($this->orderID)) {return $this->orderID;} else {return FALSE;}
		}

		private function lock()	{

			if (! $this->COPYFROM)	  {

				$this->SQL->query("	LOCK TABLES	$this->BASE.offers_header WRITE, $this->BASE.offers_data WRITE, $this->BASE.orders_header WRITE, 
									$this->BASE.orders_data WRITE, $this->STOCKBASE.finished_goods_stock WRITE, 
									$this->STOCKBASE.services WRITE		");

			}	else	  {

				$this->SQL->query("	LOCK TABLES	$this->COPYFROM.offers_header WRITE, $this->COPYFROM.offers_data WRITE, $this->BASE.offers_header WRITE, 
									$this->BASE.offers_data WRITE, $this->BASE.orders_header WRITE, $this->BASE.orders_data WRITE,
									$this->STOCKBASE.finished_goods_stock WRITE, $this->STOCKBASE.services WRITE	");
			}
		}
	
		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		public function offer2order($ID, $year)		{

			if ($year != $_SESSION['year'])	{

				$this->COPYFROM	=	'ebagdata'.$year;

				# first check te gived year exists or not

				$this->SQL->query("SELECT SCHEMA_NAME FROM INFORMATION_SCHEMA.SCHEMATA WHERE SCHEMA_NAME = '$this->COPYFROM'");

				if (! $this->SQL->num_rows()) return 'unexistentoffer';

			}

			$this->SQL->transaction();

			$this->lock();

			# if the offer is created in other year copy it to current first

			$ID	=	$this->SQL->escape($ID);

			if ($this->COPYFROM)	{

				$this->SQL->query("	SELECT `ordered`, `orderID` 
							FROM $this->COPYFROM.offers_header 
							WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

				if (! $this->SQL->num_rows())	{

					$this->SQL->rollback();

					$this->unlock();

					return 'unexistentoffer';
				}

				$RESULT	=	$this->SQL->RESULT->fetch_row();

				# note: ordered keeps values 0 => not ordered 1 => ordered

				if ($RESULT[0])		{

					$this->SQL->rollback();

					$this->unlock();

					return 'orderedbeforeoffer->personIDlong->'.$RESULT[1].'/'.$year;
				}

				$this->SQL->query(" 	SELECT * 
							FROM $this->COPYFROM.offers_header 
							WHERE `personID`='$ID' LIMIT 1	");

				$RESULT	=	$this->SQL->RESULT->fetch_row();

				# copy header

				$INSERT	=	'NULL';
				$COUNT	=	count($RESULT);

				for ($i = 1; $i < $COUNT; ++$i)	$INSERT .= ', '.$this->SQL->nr_escape($RESULT[$i]);

				$INSERT	=	"INSERT INTO $this->BASE.offers_header VALUES ($INSERT)";

				$this->SQL->query($INSERT);

				$this->offerID	=	$this->SQL->lastid();
				
				if (! $this->offerID)	{

					$this->SQL->rollback();

					$this->unlock();

					return 'unknownerror';
				}

				# note: change date of creation to current

				$this->SQL->query("	UPDATE $this->BASE.offers_header 
							SET `date_of_creation`='".date("Y-m-d")."' WHERE `personID`='$this->offerID' LIMIT 1 ");

				# leave comment about copy, the copied offer will be set to ordered

				$this->SQL->query("	SELECT `comment` 
							FROM $this->BASE.offers_header 
							WHERE `personID`='$this->offerID' LIMIT 1	");

				$RESULT		=	$this->SQL->RESULT->fetch_row();
				$comment	=	$this->SQL->r_escape($RESULT[0])." ($ID/$year => $this->offerID) ";

				$this->SQL->query("	UPDATE $this->BASE.offers_header 
							SET `comment`='$comment' 
							WHERE `personID`='$this->offerID' LIMIT 1	");

				# copy data

				$this->SQL->query("	SELECT * 
							FROM $this->COPYFROM.offers_data 
							WHERE `offerID`='$ID' AND `deleted` IS NOT NULL ORDER BY `personID` ");

				if (! $this->SQL->num_rows())	{

					$this->SQL->rollback();

					$this->unlock();

					return "corruptedrecord->personIDlong->$ID/$year";
				}

				$this->SQL->IT1_RESULT = $this->SQL->RESULT;

				while ($RESULT = $this->SQL->IT1_RESULT->fetch_assoc())	{

					foreach ($RESULT as $key=>$val) $RESULT[$key] = $this->SQL->nr_escape($val);

					extract($RESULT);

					$this->SQL->query("	INSERT INTO $this->BASE.offers_data 
								VALUES 
								(NULL, '$this->offerID', $code, $name, $quantity, $unit, $price, $tax, $type, '0')	");
				}

				unset ($this->SQL->IT1_RESULT, $code, $name, $quantity, $unit, $price, $tax, $type);

				$this->COPYREPORT	=	$ID.'/'.$year.'->'.$this->offerID;
			}

			# note: if is not just copied check that is not ordered

			if (! $this->offerID)	{

				$this->offerID	=	$ID;

				$this->SQL->query("	SELECT `ordered`, `orderID` 
							FROM $this->BASE.offers_header 
							WHERE `personID`='$this->offerID' AND `deleted` IS NOT NULL LIMIT 1	");

				if (! $this->SQL->num_rows())	{

					$this->SQL->rollback();

					$this->unlock();

					return 'unexistentoffer';
				}

				$RESULT	=	$this->SQL->RESULT->fetch_row();

				# note: ordered keeps values 0 => not ordered 1 => ordered

				if ($RESULT[0])		{

					$this->SQL->rollback();

					$this->unlock();

					return 'orderedbeforeoffer->personIDlong->'.$RESULT[1];
				}
			}

			# copy offer header
	
			$this->SQL->query("	SELECT 		`companyID`, `contactID`, `contactname`, `country`, `city`, `zip`, `street`, `delivery_country`, 
								`delivery_city`, `delivery_street`, `delivery_zip`, `article_discount`, `account1`, `bank1`, `account2`, 
								`bank2`, `deadline_days`, `delivery_day_of_week`, `contacttype`, `seller`, `comment`, `annotation`, 
								`currency`, `valuta`, `exchange_rate`, `session_discount`, `use_session_discount`, `use_article_discount`, 
								`delivery_form`, `payment_form`
					 	FROM $this->BASE.offers_header WHERE personID='$this->offerID' LIMIT 1	");

			$RESULT	=	$this->SQL->RESULT->fetch_assoc();
			
			# Add comment about offer
			
			$offercomment = $RESULT['comment'];
			
			$RESULT['comment'] .= ' ('.$this->LANG->get('offernumber').' '.$this->offerID.'/'.$_SESSION['year'].')';

			foreach ($RESULT as $key=>$val)	$RESULT[$key] = $this->SQL->nr_escape($val);

			$date_of_creation	=	date("Y-m-d");

			$date_of_deadline	=	date("Y-m-d", strtotime(str_replace("'", '', $RESULT['deadline_days'].' days')));

			extract($RESULT); unset($RESULT);
			

			$this->SQL->query("	INSERT INTO $this->BASE.orders_header VALUES (	NULL, $companyID, $contactID, $contactname, $country, $city, $zip, $street, 
												$delivery_country, $delivery_city, $delivery_street, $delivery_zip, 
												$article_discount, $account1, $bank1, $account2, $bank2, $delivery_day_of_week,
												$contacttype, $seller, $comment, $annotation, $currency, $valuta, $exchange_rate,
												$session_discount, $use_session_discount, $use_article_discount, 
												$delivery_form, $payment_form, '$this->offerID', '$date_of_creation', 
												'$date_of_deadline', '0', NULL, '0' )	");
			
			$this->orderID	=	$this->SQL->lastid();
			
			if (! $this->orderID)	{

				$this->SQL->rollback();

				$this->unlock();

				return 'unknownerror';
			}

			# Leave comment from order number on offer to
			
			$offercomment = $this->SQL->nr_escape($offercomment.' ('.$this->LANG->get('ordernumber').' '.$this->orderID.'/'.$_SESSION['year'].')');
			
			$this->SQL->query("	UPDATE $this->BASE.offers_header
						SET `comment`=$offercomment
						WHERE `personID`='$this->offerID' LIMIT 1	");

			# copy offer data
			
			$this->SQL->query("	SELECT `code`, `name`, `quantity`, `unit`, `price`, `tax`, `type` 
						FROM $this->BASE.offers_data 
						WHERE `offerID`='$this->offerID' AND `deleted` IS NOT NULL ORDER BY `personID` 	");

			if (! $this->SQL->num_rows())	{

				$this->SQL->rollback();

				$this->unlock();

				return "corruptedrecord->personIDlong->$this->offerID";
			}

			$this->SQL->IT1_RESULT = $this->SQL->RESULT;

			while ($RESULT = $this->SQL->IT1_RESULT->fetch_assoc())	{

				# note: services cannot be ordered so step over

				if ($RESULT['type'] == 's') continue;

				foreach ($RESULT as $key=>$val)		{

					if ($key != 'quantity') $RESULT[$key] = $this->SQL->nr_escape($val);
				}

				extract($RESULT);

				$this->SQL->query("	INSERT INTO $this->BASE.orders_data 
							VALUES 
							(NULL, '$this->orderID', $code, $name, '$quantity', $unit, $price, $tax, NULL, NULL, NULL, '0')	");

				# update the stock

				$this->SQL->query("	UPDATE $this->STOCKBASE.finished_goods_stock 
							SET quantity_ordered=quantity_ordered+$quantity 
							WHERE `code`=$code LIMIT 1	");

				# check stock state and set to order

				if (! $this->ORDER_TO_STOCK)	{

					$this->SQL->query("	SELECT	`quantity`, `quantity_ordered_to_stock`, `quantity_on_opened_order_to_stock`,
									`quantity_ordered`, `quantity_as_part`, `origin`
								FROM $this->STOCKBASE.finished_goods_stock 
								WHERE `code`=$code AND `deleted` IS NOT NULL LIMIT 1	");

					# note: origin 1 is product which will not be ordered

					if ($this->SQL->num_rows())	{

						$STOCKRESULT	=	$this->SQL->RESULT->fetch_assoc();

						if ($STOCKRESULT['origin'] != 1)	{

							if (($STOCKRESULT['quantity'] + $STOCKRESULT['quantity_ordered_to_stock'] + $STOCKRESULT['quantity_on_opened_order_to_stock'] - $STOCKRESULT['quantity_ordered'] - $STOCKRESULT['quantity_as_part']) < 0) $this->ORDER_TO_STOCK = TRUE;
						}
					}
				}
			}

			# at the end check the order is not empty (if was offer only services)

			$this->SQL->query("	SELECT `personID` 
						FROM $this->BASE.orders_data 
						WHERE `orderID`='$this->orderID' LIMIT 1	");

			# Leave comment 

			if (! $this->SQL->num_rows())	{

				$this->SQL->rollback();

				$this->unlock();

				return 'emptyorder';
			}

			# set the offer to ordered

			$this->SQL->query("	UPDATE $this->BASE.offers_header 
						SET `ordered`='1', `orderID`='$this->orderID'
						WHERE `personID`='$this->offerID' LIMIT 1	");

			unset($this->SQL->IT1_RESULT);

			$this->SQL->commit();

			$this->unlock();

			return TRUE;	
		}

	}

?>
