<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 5.0.0
	 */

	/**
	 * eBag production phases details
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class PHASEDETAILS	{

		function __construct()	{

			global $__SQL, $__CONF, $__LANG;

			$this->SQL	=	&$__SQL;

			$this->LANG	=	&$__LANG;

			$this->FORMAT	=	$__CONF->get('date', 'sql_format');
			
			$this->APC	=	$__CONF->get('cache', 'use_apc_cache');

			$this->BASE	=	$_SESSION['BASE'];
		}

		public function base($BASE)	{

			$this->BASE	=	$BASE;
		}

		private function lock()	{

			$this->SQL->query("LOCK TABLES 	$this->BASE.production_orders_header WRITE, 
							$this->BASE.production_orders_phases WRITE, 
							$this->BASE.addressbook WRITE, 
							$this->BASE.employees WRITE"	);
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		public function read($ID)	{

			$DATA	=	FALSE;

			# first check te gived base exists or not

			$this->SQL->query("SELECT SCHEMA_NAME FROM INFORMATION_SCHEMA.SCHEMATA WHERE SCHEMA_NAME = '$this->BASE'");

			if (! $this->SQL->num_rows()) return $DATA;
			
			# load phases

			$__PHASES	=	new PHASEloader($this->APC);

			$PHASES		=	$__PHASES->getall();

			unset($__PHASES);

			# read
			
			$this->lock();

			# read header data

			$this->SQL->query("	SELECT	`code` AS `articalcode`, `articalname`, `contactname`, `drawingID`
						FROM $this->BASE.production_orders_header
						WHERE personID='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

			if (! $this->SQL->num_rows())	{

				$this->unlock();

				return $DATA;
			}

			$DATA	=	$this->SQL->RESULT->fetch_assoc();

			# note: the phases delete is permanently

			$this->SQL->query("	SELECT `production_phase`, `finisher`, `process_time`,
						DATE_FORMAT(`date`, '$this->FORMAT') AS `date`
						FROM $this->BASE.production_orders_phases
						WHERE `productionorderID`='$ID'	ORDER BY `personID` ");

			if ($this->SQL->num_rows())	{
			
				# Initialize vars

				$DATA['productionorderID'] = $ID;

				$DATA['productionorder_year']	=	str_replace('ebagdata', '' , $this->BASE);
				
				$DATA['production_phase'] = $DATA['date'] = $DATA['process_time'] = $DATA['finisher'] = array();

				if ($this->SQL->num_rows())	{
				
					$this->SQL->IT1_RESULT = $this->SQL->RESULT;

					while ($RESULT = $this->SQL->IT1_RESULT->fetch_assoc())	{

						$DATA['production_phase'][]	=	$PHASES[$RESULT['production_phase']];
						$DATA['date'][]			=	$RESULT['date'];
						$DATA['process_time'][]		=	$RESULT['process_time'];
						$FINISHER			=	$RESULT['finisher'];

						if ($FINISHER)	{

							list($TYPE, $FINISHERID)	=	explode('_', $FINISHER);

							if ($TYPE == 'employee')	{

								$COMMAND = "	SELECT `employeename` 
										FROM $this->BASE.employees 
										WHERE `personID`='$FINISHERID' AND `deleted` IS NOT NULL LIMIT 1	";

							}	else	   {

								$COMMAND = "	SELECT `contactname` 
										FROM $this->BASE.addressbook 
										WHERE `personID`='$FINISHERID' AND `deleted` IS NOT NULL LIMIT 1	";
							}

							$this->SQL->query($COMMAND);

							if ($this->SQL->num_rows())	{

								$RESULT1 = $this->SQL->RESULT->fetch_row();

								$DATA['finisher'][]	=	$RESULT1[0];

							}	else	 {

								$DATA['finisher'][]	=	$this->LANG->get('finisherwasdeleted');
							}
						}
					}

					unset($this->SQL->IT1_RESULT);
				
				}	else	  {
				
					$DATA	=	FALSE;
				}
			}

			$this->unlock();

			return $DATA;
		}
	}
?>
