<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag service delete
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class SERVICEDELETE	{

		function __construct()	{

			global $__SQL;

			$this->SQL		=	&$__SQL;

			$this->BASE		=	$_SESSION['BASE'];

			$this->STOCKBASE	=	'ebagstock';
		}	

		private function lock()	  {

			$this->get_open_years();

			$TO_LOCK	=	'';

			foreach ($this->OPENED as $YEAR) $TO_LOCK .= ", ebagdata$YEAR.services_data WRITE";

			$this->SQL->query("LOCK TABLES 	ebag.years WRITE, 
							$this->STOCKBASE.services WRITE, 
							$this->BASE.employees_items_bonuses WRITE,
							$this->STOCKBASE.feedstock_requests_list WRITE ".$TO_LOCK);
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		private function get_open_years()	{

			$this->SQL->query('	SELECT `year` 
						FROM ebag.years 
						WHERE `closed` IS NULL	');

			$this->OPENED	=	array();

			while ($RESULT = $this->SQL->RESULT->fetch_row()) $this->OPENED[] = $RESULT[0];
		}

		public function delete($ID)	{

			$ID	=	$this->SQL->escape($ID);

			$this->SQL->transaction();
		
			$this->lock();

			# check the record is not deleted in meantime

			$this->SQL->query("	SELECT `code`
						FROM $this->STOCKBASE.services
						WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

			if (! $this->SQL->num_rows())	{

				$this->SQL->rollback();

				$this->unlock();

				return 'deletedinmeantime';
			}

			$RESULT	= $this->SQL->RESULT->fetch_assoc();

			$code = $this->SQL->r_escape($RESULT['code']);
			
			foreach ($this->OPENED as $YEAR)	{

				$this->SQL->query("	SELECT `personID` 
							FROM ebagdata$YEAR.services_data
							WHERE `code`='$code' AND `deleted` IS NOT NULL LIMIT 1	");

				if ($this->SQL->num_rows())	{

					$errtxt	= "ordered_service->year->$YEAR";

					break;
				}
			} 
			
			# check employees_bonuses
			
			if (! isset($errtxt))	{
			
				$this->SQL->query("	SELECT `personID`
							FROM $this->BASE.employees_items_bonuses
							WHERE `stock_type`='2' AND `stockID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");
							
				if ($this->SQL->num_rows()) $errtxt = 'bonusdefined2item';
			}

			if (isset($errtxt))	{

				$this->SQL->rollback();

				$this->unlock();

				return $errtxt;
			}
			
			# delete the service

			$this->SQL->query("	UPDATE $this->STOCKBASE.services 
						SET `deleted`=NULL 
						WHERE `personID`='$ID' LIMIT 1	");
						
			# delete the connected feedstock request to
				
			$this->SQL->query("	DELETE FROM $this->STOCKBASE.feedstock_requests_list
						WHERE `serviceID`='$ID'	");

			$this->SQL->commit();

			$this->unlock();

			return TRUE;			
		}
	}
?>
