<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag operativ suplie update
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	load_f('is_real_positive');
	
	load_f('is_longer');

	class SUPLIEUPDATE	{

		function __construct()	{

			global $__SQL;

			$this->SQL		=	&$__SQL;
			$this->STOCKBASE	=	'ebagstock';
		}

		private function prepare($DATA)		{

			# Check user input

			if ((is_empty($DATA['supliename'])) or 
			    (is_empty($DATA['code'])) or
			    (is_longer($DATA['code'], 25)) or
			    (is_empty($DATA['unit']))) return FALSE;

			# note: accept 0 as price because can be internal production

			if ((! is_empty($DATA['purchase_price'])) && ((! is_numeric($DATA['purchase_price'])) or ($DATA['purchase_price'] < 0))) return FALSE;
			
			# Change empty purchase_price to zero
			
			if (is_empty($DATA['purchase_price'])) $DATA['purchase_price'] = 0;

			# Escape the data

			foreach ($DATA as $key=>$val)	$DATA[$key] = $this->SQL->n_escape($val);

			return $DATA;
		}

		public function lock()	{

			$this->SQL->query("LOCK TABLES ebag.years WRITE");

			$this->get_open_years();

			$TO_LOCK	=	'';

			foreach ($this->OPENED as $YEAR)	{

				$TO_LOCK	.=	", ebagdata$YEAR.operating_suplies_enter WRITE, 
							   ebagdata$YEAR.production_orders_header WRITE	";
			}

			$this->SQL->query("LOCK TABLES $this->STOCKBASE.operating_suplies WRITE".$TO_LOCK);
		}

		public function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		private function get_open_years()	{

			$this->SQL->query('	SELECT `year` 
						FROM ebag.years 
						WHERE `closed` IS NULL');

			$this->OPENED	=	array();

			while ($RESULT = $this->SQL->RESULT->fetch_row())	$this->OPENED[] = $RESULT[0];
		}


		public function update($ID, $DATA)	{

			if (! $DATA = $this->prepare($DATA)) return 'usererror';

			$this->lock();

			if (! count($this->OPENED)) return 'noopenyearsfound';

			$ID = $this->SQL->escape($ID);

			extract($DATA); unset($DATA);

			# check the new operativ suplie code exists

			$this->SQL->query("	SELECT `supliename` 
						FROM $this->STOCKBASE.operating_suplies 
						WHERE `personID`!='$ID' AND `code`=$code AND `deleted` IS NOT NULL LIMIT 1	");

			if ($this->SQL->num_rows())	{

				$this->unlock();
				return 'feedstockexists';
			}

			# check the operativ suplie is not deleted in meantime

			$this->SQL->query("	SELECT `code`
						FROM $this->STOCKBASE.operating_suplies 
						WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

			if (! $this->SQL->num_rows())	{

				$this->unlock();
				return 'deletedinmeantime';
			}

			$RESULT	=	$this->SQL->RESULT->fetch_assoc();

			# if the artical name and code is changed, see is possible to change or not

			if ($code != "'".$RESULT['code']."'")	{

				$OLDCODE	=	$this->SQL->r_escape($RESULT['code']);

				foreach ($this->OPENED as $YEAR)	{
				
					# check enter to stock for open years

					$this->SQL->query("	SELECT `personID` 
								FROM ebagdata$YEAR.operating_suplies_enter 
								WHERE `code`='$OLDCODE' AND `deleted` IS NOT NULL LIMIT 1	");

					if ($this->SQL->num_rows())	{

						$errtxt = "ordered_or_entered->year->$YEAR";

						break;
					}
					
					# check production for open years
					
					$this->SQL->query("	SELECT `personID`
								FROM ebagdata$YEAR.production_orders_header
								WHERE `code`='$OLDCODE' AND `deleted` IS NOT NULL LIMIT 1	");
								
					if ($this->SQL->num_rows())	{

						$errtxt = "item_in_production->year->$YEAR";

						break;
					}
				}
			}

			if (isset($errtxt))	{

				$this->unlock();

				return $errtxt;
			}

			$COMMAND = "	UPDATE $this->STOCKBASE.operating_suplies SET	`code`=$code, `supliename`=$supliename, `dimensions`=$dimensions, 
											`unit`=$unit, `purchase_price`=$purchase_price, `comment`=$comment
					WHERE `personID`='$ID' LIMIT 1";

			$this->SQL->query($COMMAND);

			$this->unlock();

			return TRUE;

		}
	}

?>
