<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag background low priority backup
	 */

	ignore_user_abort(TRUE);

	define('BASEDIR', '../');
	
	# Set time limit
	
	set_time_limit(0);

	# Load basic functions

	require(BASEDIR.'helpers/basichelpers.php');
	
	# Sets mbstring functions
	
	mb_internal_encoding('UTF-8');
	
	mb_regex_encoding('UTF-8');

	# Reads the configuration

	load_c('INIload');

	$__CONF	= new INI_load(BASEDIR.'conf/eBag.ini');

	# Sets error handler

	load_c('Errorhandler');

	$__HANDLER = new ERRHANDLER();
	
	$__HANDLER -> start();

	# Sets session handler

	load_c('Sessionhandler');

	$__SESS	= new MysqlSession();
	
	# session_abort();
	
	$__SESS -> readonly(); 
	
	$__SESS	-> set_session_handler();
	
	register_shutdown_function('session_write_close');
	
	session_start();
	
	if (! isset($_SESSION['permission'])) exit;
	
	# Turn off magic quotes runtime

	if (get_magic_quotes_runtime())	set_magic_quotes_runtime(false);
	
	# starting backup
	
	load_c('SQL');

	$__SQL	= new SQL();
	
	load_c('BACKUP');

	$__BACKUP = new BACKUP();

	$__BACKUP -> backup_directory($__CONF->get('backup', 'directory'));
	
	if (isset($_GET['forced_backup'])) $__BACKUP -> force();
	
	if (isset($_GET['dump_structure'])) $__BACKUP -> reset_structure();

	$r = $__BACKUP -> create();
	
	if (! $r) $r = '0';
	
	echo 'r_'.$r;
	
?>
